// C Source File
// Created 4/17/2007; 2:04:24 PM

// Delete or comment out the items you do not need.
#define COMMENT_STRING         "Place your comment here."
#define COMMENT_PROGRAM_NAME   "Place your program name here."
#define COMMENT_VERSION_STRING "Place your version string here."
#define COMMENT_VERSION_NUMBER 0,0,0,0 /* major, minor, revision, subrevision */
#define COMMENT_AUTHORS        "Place your author name(s) here."
#include <tigcclib.h>
#include "fat.h"
#include "utils.h"
#include "indices.h"
#include "intro.h"
#include "extgraph.h"
#include "files.h"
#include "rayline.h"
#include "weapons.h"
#include "maps.h"
#define MAX_DOOR_WAIT 50
int switchon = 0;
int BookNumber = 0;
// Main Function
int glasseson = 0;
int havebook = 0;
int havebox = 0;
int havepaper = 0;
int havedecoder = 0;
int ghostson = 1;
int tag = 1;
int playerdead = 0;
char code[18] = "";
int invincible = 0;
int havekey = 0;
int havewhitekey = 0;
int haveironkey = 0;
int havekey2 = 0;
int MAP_WIDTH = 16;
int MAP_HEIGHT = 16;
//short a=0;
int loopindex = 0;
int current_map = 1;
int USE_COUNTER = 0;
int havecharm = 0;
int lives = 5;
int timer = 0;
int usegun = 0;
int shooting = 0;
int NO_LOGO = 0;
int havegun = 0;
int timer2 = 0;
int timer3 = 0;
int timer4 = 0;
int arrows = 5;
short doortimers[MAX_NR_DOORS];
short lockeddoors[32*32];
short lockedirondoors[32*32];
short lockedwhitedoors[32*32];
int YouWin = 1;




/******************************************************************************
*
* project name:   Thirteen Ghosts
* file name:      Main Program.c 
* initial date:   4/17/07
* author:         Aaron Miller
*
* description:    Thirteen Ghosts - Adventure game 
*
******************************************************************************/



//-------------------------------------------------------------------
// defines the used map: 0 = no wall, 1 = texture1, 2 = texture2 etc.
// NOTE: the array tex64 which gets handed over to the engine as
//       part of the FATCONFIG structure has to as much textures as
//       you have specified in this map.
//       For example: if the highest number in the map is 3 then
//       tex64 has to hold 3 textures (64x64 pixels with 2 planes)
//-------------------------------------------------------------------

//=============================================================================
// returns 0 if move would bring the character too near to a wall
//=============================================================================


//-----------------------------------------------------------------------------
// include file containing the texture and genericdata indices into fatdtx
// (automatically generated by TexMaker)
//-----------------------------------------------------------------------------

short display_offset  = 0; // will be set depending on calctype (TI89 or TI92p)
short display_offsetx = 0; // will be set depending on calctype (TI89 or TI92p)
short display_offsety = 0; // will be set depending on calctype (TI89 or TI92p)

static inline void LoadPic(unsigned long* gui) {
    unsigned long* src1;
    unsigned long* src2;
    unsigned long* dest1;
    unsigned long* dest2;
    short i;

    src1 = gui;
    src2 = &gui[500];
    for (i=0;i<100;i++) {
        dest1 = (unsigned long*)(GetPlane(0)+(i<<5)-(i<<1)+display_offset);
        dest2 = (unsigned long*)(GetPlane(1)+(i<<5)-(i<<1)+display_offset);
        *dest1++=*src1++,*dest1++=*src1++,*dest1++=*src1++,*dest1++=*src1++,*dest1++=*src1++;
        *dest2++=*src2++,*dest2++=*src2++,*dest2++=*src2++,*dest2++=*src2++,*dest2++=*src2++;
    }
}

static void dissolve(void) {
	unsigned short  seq = 1;
	unsigned char   pixmask;
	unsigned short  byteoffset;

	do {
		pixmask    = seq & 0x7;
		byteoffset = seq >> 3;

        if (byteoffset < LCD_SIZE) {
            pixmask = 0x80 >> pixmask;

            //-------------------------------------
            // if pixel in plane1 is set, delete it
            // otherwise set it
            //-------------------------------------
        	if (*(unsigned char *)(GetPlane(LIGHT_PLANE)+byteoffset) & pixmask) {
          	    *(unsigned char *)(GetPlane(LIGHT_PLANE)+byteoffset) &= ~pixmask;
            }
        	else {
          	    *(unsigned char *)(GetPlane(LIGHT_PLANE)+byteoffset) |= pixmask;
            }

            //-------------------------------------
            // if pixel in plane2 is set, delete it
            // otherwise set it
            //-------------------------------------
        	if (*(unsigned char *)(GetPlane(DARK_PLANE)+byteoffset) & pixmask) {
          	    *(unsigned char *)(GetPlane(DARK_PLANE)+byteoffset) &= ~pixmask;
          	}
        	else {
          	    *(unsigned char *)(GetPlane(DARK_PLANE)+byteoffset) |= pixmask;
            }

        }

        if (seq & 1) seq = (seq>>1)^0x6000;
        else         seq = seq>>1;
    }
    while (seq != 1);
}

void PutLogo(void)
{
	GraySprite32_OR(96 + display_offsetx,0 + display_offsety,100,hudstrip1layer1,hudstrip1layer2,GrayGetPlane((LIGHT_PLANE)),GrayGetPlane((DARK_PLANE)));
  GraySprite32_OR(128 + display_offsetx,0 + display_offsety,100,hudstrip2layer1,hudstrip2layer2,GrayGetPlane((LIGHT_PLANE)),GrayGetPlane((DARK_PLANE)));  
}

//=============================================================================
// initializes GUI (darkgray background, tiny logo and counter)
//=============================================================================
void InitGUI(COUNTER *counter) {
    
    if (NO_LOGO != 1)
    {
    	PutLogo();
    }
    
        	
    FontSetSys(F_6x8);
    DrawGrayStr(100+display_offsetx,36+display_offsety,"Lives:",A_REPLACE);
    DrawGrayStr(100+display_offsetx,44+display_offsety,"Arrows:",A_REPLACE);
    
    		
    	//INITIALIZES COUNTER
    	if (USE_COUNTER == 1)
    	{
			InitCounter(counter,158-6*5+display_offsetx,99-10+display_offsety,3,0);
   		DrawCounter(counter);
   		}

}


							
//Darkness!=================================================================
//===========================================================================

void PredrawCallback(FATCONFIG* fc,DEPTHDATA* dd) {
    short i;

    fc = fc; // just to make the compiler happy. otherwise it will complain
             // about the unused parameter fc

   // if (dont_modify) return;
   for (i=0;i<ANGLE_060;i++) {
        if (dd->distance[i] < 101) continue;
        if (dd->distance[i] < 201) {
            dd->lightdata[i<<1]     = 0xffffffffL;
            dd->lightdata[(i<<1)+1] = 0xffffffffL;
        }
        else if (dd->distance[i] < 301) {
            dd->darkdata[i<<1]     = 0xffffffffL;
            dd->darkdata[(i<<1)+1] = 0xffffffffL;
        }
        else {
            dd->lightdata[i<<1]     = 0xffffffffL;
            dd->lightdata[(i<<1)+1] = 0xffffffffL;
            dd->darkdata[i<<1]      = 0xffffffffL;
            dd->darkdata[(i<<1)+1]  = 0xffffffffL;
        }
    }
}

void PutSprites(FATCONFIG* fc,FATSPRITE* sprites)
{
	short x, y, index, value;
    for (y=1; y<(fc->map_height-1); ++y) {
        for (x=1; x<(fc->map_width-1); ++x) {
        		for (value = 0; value > -17; value--)
        		{
        		for (index = 0; index < 16;index++)
        		{
        				if (fc->map_data[y*fc->map_width+x] == value && abs(value) == (abs(index+1))) {
               		 sprites[index].xpos = ((x*64)+32);
              		  sprites[index].ypos = ((y*64)+32);
          		  }
        		}
        		}
            
        }
   }
}


//=============================================================================
// output frame count ever 10th frame
//=============================================================================
void frame_drawn(FATCONFIG* fc,COUNTER* counter) {
    short i;
    if (fc->frame_counter%10==0) {
        // we starting incrementing at 2nd position and not on first!
        for (i=counter->length-2;i>=0;i--) {

            counter->newcount[i] = counter->newcount[i]+1;
            if (counter->newcount[i] < 10) break;
            else                           counter->newcount[i]=0;
        }
       if (USE_COUNTER == 1)
       {
       DrawCounter(counter);
       }
       
       if (counter->oldcount[0] == 1)
        {
        	USE_COUNTER = 0;
       		InitGUI(counter);
       		invincible = 0;
        }
        
    }
       
}


void DoorLocked(void)
{
FAT_AllKeysReleased();
char *light_buffer, *dark_buffer;

			if(!(light_buffer = (char*) malloc(LCD_SIZE)))
			{

  						playerdead=1;
   						return;
 						 //handle errors and return

			}

		if(!(dark_buffer = (char*) malloc(LCD_SIZE)))
			{

  						playerdead=1;
   						return;
 						 //handle errors and return

			}
	 
	 memcpy(light_buffer, GrayGetPlane(LIGHT_PLANE), LCD_SIZE);
   memcpy(dark_buffer, GrayGetPlane(DARK_PLANE), LCD_SIZE);
   FontSetSys(F_4x6);
 
   GraySetAMSPlane((LIGHT_PLANE)); 
   DrawStr(112+(display_offsetx),74+(display_offsety),"This Door Is",A_XOR);
	 DrawStr(112+(display_offsetx),81+(display_offsety),"   LOCKED",A_XOR);

   GraySetAMSPlane((DARK_PLANE)); 
   DrawStr(112+(display_offsetx),74+(display_offsety),"This Door Is",A_XOR);
	 DrawStr(112+(display_offsetx),81+(display_offsety),"   LOCKED",A_XOR);
	 
	 
   
   //memcpy(GrayGetPlane(LIGHT_PLANE), light_buffer, LCD_SIZE);
   //memcpy(GrayGetPlane(DARK_PLANE), dark_buffer, LCD_SIZE);
   
   			if(light_buffer) free(light_buffer);

  			if(dark_buffer) free(dark_buffer);

}

void UpdateSwitchDoor(FATCONFIG* fc,TEXCONFIG* textures,int tex)
{
//	FAT_AllKeysReleased();
	short tile_x = ((FAT_Cos16384(fc->cam_orientation) >> 8)+fc->cam_xpos)>>6;
  short tile_y = ((FAT_Sin16384(fc->cam_orientation) >> 8)+fc->cam_ypos)>>6;
  
  short x, y;
	if (fc->map_data[tile_y*fc->map_width+tile_x] == tex)
	{
		for (x=0; x<fc->map_width-1; x++)
		{
			for (y=0; y<fc->map_height-1; y++)
			{
				if (fc->map_data[tile_y*fc->map_width+tile_x] == tex)
				{
					fc->map_data[tile_y*fc->map_width+tile_x] = 127;
					FAT_AddDoor(tile_x,tile_y, DOOR_VERTICAL, DOOR_OPENING, 0, &textures[tex-1],&textures[tex-1], NULL);			
				}
			}
		}
	}
	else 
	{
		return;
	}
}

void UpdateSecret(FATCONFIG* fc,TEXCONFIG* textures,int tex)
{

	short tile_x = ((FAT_Cos16384(fc->cam_orientation) >> 8)+fc->cam_xpos)>>6;
  short tile_y = ((FAT_Sin16384(fc->cam_orientation) >> 8)+fc->cam_ypos)>>6;
  
  short x, y;
	if (fc->map_data[tile_y*fc->map_width+tile_x] == tex)
	{
		for (x=0; x<fc->map_width-1; x++)
		{
			for (y=0; y<fc->map_height-1; y++)
			{
				if (fc->map_data[tile_y*fc->map_width+tile_x] == tex)
				{
					fc->map_data[tile_y*fc->map_width+tile_x] = 127;
					FAT_AddDoor(tile_x,tile_y, DOOR_VERTICAL, DOOR_OPENING, 0,&textures[tex-1],&textures[tex-1], NULL);					
				}
			}
		}
	}
	else 
	{
		return;
	}
	
}

int IsLocked(FATCONFIG* fc,short lockeddoors[],short lockedirondoors[],short lockedwhitedoors[])
{	
	short tile_x = ((FAT_Cos16384(fc->cam_orientation) >> 8)+fc->cam_xpos)>>6;
  short tile_y = ((FAT_Sin16384(fc->cam_orientation) >> 8)+fc->cam_ypos)>>6;
	
		if (lockeddoors[tile_y * fc->map_width + tile_x] == 1 && havekey != 1)
		{
			return 1;
		}
		else if (lockedirondoors[tile_y * fc->map_width + tile_x] == 1 && haveironkey != 1)
		{
			return 1;
		}
		else if (lockedwhitedoors[tile_y * fc->map_width + tile_x] == 1 && havewhitekey != 1)
		{
			return 1;
		}
	
	
	
return 0;

}

void UpdateSwitch(FATCONFIG* fc)
{
	FAT_AllKeysReleased();
	short tile_x = ((FAT_Cos16384(fc->cam_orientation) >> 8)+fc->cam_xpos)>>6;
  short tile_y = ((FAT_Sin16384(fc->cam_orientation) >> 8)+fc->cam_ypos)>>6;
	
	short x, y;
	if (fc->map_data[tile_y*fc->map_width+tile_x] == 12 || fc->map_data[tile_y*fc->map_width+tile_x] == 11 )
	{
		for (x=0; x<fc->map_width-1; x++)
		{
			for (y=0; y<fc->map_height-1; y++)
			{
				if (fc->map_data[tile_y*fc->map_width+tile_x] == 12)
				{
					if (switchon < 0) switchon = 1;
					switchon += 1;
					fc->map_data[tile_y*fc->map_width+tile_x] = 11;
				}
				else 
				{
					if (switchon > 0) switchon -= 1;
					fc->map_data[tile_y*fc->map_width+tile_x] = 12;
				}
			}
		}
	}
	else 
	{
		return;
	}
	
}

//=============================================================================
// updates the door in front of the player
//=============================================================================

/// HANDLEDOORS CODE CURTESY OF MALCOLM SMITH! HE WROTE THIS, I JUST EDITED IT A LITTLE. 
static inline void HandleDoors(FATCONFIG* fc)
{
	short a;
	FATDOOR *curdoor = FAT_GetDoorsArray();
	
	for(a=0;a<FAT_GetNrDoors(); a++)
	{
		if(curdoor->state==DOOR_OPEN)
		{
			if(doortimers[a]!=MAX_DOOR_WAIT) doortimers[a]++;
			//if(ggg->doortimers[a]==MAX_DOOR_WAIT)
			else
			{

				if ((fc->cam_xpos/64) != curdoor->xtile && (fc->cam_ypos/64) != curdoor->ytile)
				{
					doortimers[a] = 0;
					curdoor->state = DOOR_CLOSING;
				}
			}
		}
		else
		{
        if (curdoor->state == DOOR_OPENING) {
            curdoor->position+=4;
            if (curdoor->position >= 64) {
	            	curdoor->position = 64;
                curdoor->state = DOOR_OPEN;
                *(fc->map_data + fc->map_width * curdoor->ytile
                 + curdoor->xtile) = OPEN_DOOR_TILE;
            }
        }
        else if (curdoor->state == DOOR_CLOSING) {
            curdoor->position-=4;
            if (curdoor->position <= 0) {
                curdoor->position = 0;
                curdoor->state = DOOR_CLOSED;
            }
                *(fc->map_data + fc->map_width * curdoor->ytile
                 + curdoor->xtile) = CLOSED_DOOR_TILE;
        }
		}

		++curdoor;
	}
}

void UpdateDoor(FATCONFIG* fc, short open) {
    short tile_x = ((FAT_Cos16384(fc->cam_orientation) >> 8)+fc->cam_xpos)>>6;
    short tile_y = ((FAT_Sin16384(fc->cam_orientation) >> 8)+fc->cam_ypos)>>6;
		if (fc->cam_xpos == tile_x || fc->cam_ypos == tile_y) return; // cannot be on same tile!
		
FATDOOR* door = FAT_GetDoor(tile_x,tile_y);

if (!door) return;

	if ((IsLocked(fc,lockeddoors,lockedirondoors,lockedwhitedoors)) == 1)
	{
		DoorLocked();
		return;
	}

		
    if (open) {
        if (door->state != DOOR_OPEN) {
            if (door->position == 64) {
                door->state = DOOR_OPEN;
                *(fc->map_data + fc->map_width * tile_y + tile_x) = -127;
            }
            else {
                door->state = DOOR_OPENING;
            }
          }
        
    }
    else {
        if (door->state != DOOR_CLOSED) {
            if (!door->position) {
                door->state = DOOR_CLOSED;
            }
            else {
                door->state = DOOR_CLOSING;
            }
            *(fc->map_data + fc->map_width * tile_y + tile_x) = 127;
        }
    }
    
    
     
}         

//=============================================================================
// as usual ... our main function
//=============================================================================

void _main(void) {
    int n=16;
    PADSTATES       key    = 0;
    unsigned short* bg_img;
    unsigned short* hud_plane1 = NULL;
    unsigned short*	hud_plane2 = NULL;
    unsigned short* hud_mask = NULL;
     unsigned short* hud2_plane1 = NULL;
    unsigned short*	hud2_plane2 = NULL;
    unsigned short* hud_mask2 = NULL;
    short           i,j;
    unsigned short* dest;
    TEXCONFIG       textures[40];
    TEXCONFIG 			charm_tex[1];
    TEXCONFIG 			book_tex[1];
    TEXCONFIG				box_tex[1];
    TEXCONFIG 			paper_tex[1];
    TEXCONFIG				skeleton_tex[1];
    TEXCONFIG 			reaper_tex[1];
    TEXCONFIG 			huge_zombie_tex[1];
    TEXCONFIG 			glasses_tex[1];
    TEXCONFIG				key_tex[1];
    TEXCONFIG 			crossbow_tex[1];
    FATSPRITE				sprites[n];
    LCD_BUFFER      lcd;
    HANDLE          texfile = 0;
    unsigned char*  src     = 0;
    unsigned short* background = NULL;
    short           result;
    COUNTER         frames_display;
		
		
    FATCONFIG fc = {
        MAP_WIDTH,  // width of map
        MAP_HEIGHT, // height of map
        map,        // pointer to map data
        textures,   // pointer to textures array
        n,          // number of sprites
        sprites,       // the sprite array
        96,         // start pos_x
        96,         // start pos_y
        ANGLE_EAST, // orientation
        NULL,       // destination plane0
        NULL,       // destination plane1
        NULL,       // background image
        0           // frame counter
    };
  
  //   -------------------------------------------------------------------------
  //   before we try to do anything else we have to initialize the engine
   //  its only valid to proceed if FAT_LOADOKAY gets returned
   // -------------------------------------------------------------------------
  //-------------------------------------------------------------------------
  // before we try to do anything else we have to initialize the FAT engine
  // its only valid to proceed if FAT_LOADOKAY gets returned
  //-------------------------------------------------------------------------
  if ((result = FAT_LoadEngine()) != FAT_LOADOKAY) {
        switch(result) {
            case FAT_NOTGHOSTSPACE: ST_helpMsg("ERROR: client no exepacked!");break;
            case FAT_NOTFOUND:      ST_helpMsg("ERROR: no matching engine found");break;
            case FAT_LOCKFAILED:    ST_helpMsg("ERROR: locking engine failed");break;
            case FAT_OUTOFMEM:      ST_helpMsg("ERROR: out of memory");break;
            default:                ST_helpMsg("ERROR: unknown errorcode");break;
        }
        ngetchx();
        ngetchx();
        return;
    }

 
 
    //-------------------------------------------------------------------------
    // try to load the used textures from textures.89y ...
    //-------------------------------------------------------------------------
    if ((texfile = FAT_GetHandleOfFile("textures"))) {
        if ((src = FAT_LockHandleOfFile(texfile))) {
            // load house wall textures
            if (!FAT_LoadTextures(textures,src+2,TEXIDX_TEXTURE1,40)) {      	
                src = 0; // just to indicate something went wrong
            }
            if (!FAT_LoadTextures(book_tex,src+2,TEXIDX_BOOK,1)) {      	
                src = 0; // just to indicate something went wrong
            }
             if (!FAT_LoadTextures(box_tex,src+2,TEXIDX_BOX,1)) {      	
                src = 0; // just to indicate something went wrong
            }
            if (!FAT_LoadTextures(paper_tex,src+2,TEXIDX_PAPER1,1)) {      	
                src = 0; // just to indicate something went wrong
            }
            if (!FAT_LoadTextures(skeleton_tex,src+2,TEXIDX_SKELETON,1)) {      	
                src = 0; // just to indicate something went wrong
            }
            if (!FAT_LoadTextures(charm_tex,src+2,TEXIDX_CHARM,1)) {      	
                src = 0; // just to indicate something went wrong
            }
            if (!FAT_LoadTextures(reaper_tex,src+2,TEXIDX_REAPER,1)) {      	
                src = 0; // just to indicate something went wrong
            }
             if (!FAT_LoadTextures(huge_zombie_tex,src+2,TEXIDX_HUGEZOMBIE,1)) {      	
                src = 0; // just to indicate something went wrong
            }
            if (!FAT_LoadTextures(glasses_tex,src+2,TEXIDX_GLASSES,1)) {      	
                src = 0; // just to indicate something went wrong
            }
            if (!FAT_LoadTextures(key_tex,src+2,TEXIDX_KEY,1)) {      	
                src = 0; // just to indicate something went wrong
            }
            if (!FAT_LoadTextures(crossbow_tex,src+2,TEXIDX_CROSSBOW,1)) {      	
                src = 0; // just to indicate something went wrong
            }
             if (!src || !(background=FAT_GetGenericData(src+2,GENIDX_BACKGROUND,2304))) {
                src = 0;
            }
            
            if (!src || !(hud_plane1=FAT_GetGenericData(src+2,GENIDX_HUDPLANE1,1152))) {
                src = 0;
            }
             if (!src || !(hud_plane2=FAT_GetGenericData(src+2,GENIDX_HUDPLANE2,1152))) {
                src = 0;
            }
          	 if (!src || !(hud_mask=FAT_GetGenericData(src+2,GENIDX_CROSSBOWHUDMASK,576))) {
                src = 0;
            }
            
            if (!src || !(hud2_plane1=FAT_GetGenericData(src+2,GENIDX_HUD2PLANE1,1152))) {
                src = 0;
            }
             if (!src || !(hud2_plane2=FAT_GetGenericData(src+2,GENIDX_HUD2PLANE2,1152))) {
                src = 0;
            }
          	 if (!src || !(hud_mask2=FAT_GetGenericData(src+2,GENIDX_CROSSBOWHUDMASK2,576))) {
                src = 0;
            }
            
            
            
            
         }

    }

void bookhandler(void)
{
// HELP WITH CODE COURTESY OF MALCOLM SMITH 

 if (havebook==1 && fc.map_data == map)
  {

   ClearGrayScreen();
   FontSetSys(F_4x6);
   
   DrawGrayStr(1,1,"If you have found this book",A_NORMAL);
   DrawGrayStr(1,7,"then you are now locked in the basement",A_NORMAL);  
   DrawGrayStr(1,14,"of the Delacroix mansion, you will find",A_NORMAL);
   DrawGrayStr(1,21,"other items like this on the various",A_NORMAL);
   DrawGrayStr(1,28,"floors of this building. They will",A_NORMAL);
   DrawGrayStr(1,35,"hold valuable clues on how to unlock",A_NORMAL);
   DrawGrayStr(1,42,"the codes you may find. These codes are",A_NORMAL);
	 DrawGrayStr(1,49,"nessisary for unlocking the elevator.",A_NORMAL);
	 DrawGrayStr(1,56,"If you wish to escape with your life,",A_NORMAL);
	 DrawGrayStr(1,63,"then you must learn to pay attention to",A_NORMAL);
	 DrawGrayStr(1,70,"subtle clues. Good Luck.",A_NORMAL);
	 DrawGrayStr(1,77,"-Xavier Delacroix",A_NORMAL);
   
   FAT_AllKeysReleased();
   FAT_WaitKeyPressed();
   FAT_AllKeysReleased();
   
  }
   if (havebook == 1 && fc.map_data == map2)
  {

   FontSetSys(F_4x6);
   ClearGrayScreen();
   
   DrawGrayStr(1,1,"All right, so you've made it this far.",A_NORMAL);
   DrawGrayStr(1,8,"I see you have some knowledge of literature.",A_NORMAL);
   DrawGrayStr(1,15,"Then perhaps you will be able to figure this",A_NORMAL);
   DrawGrayStr(1,22,"one out.",A_NORMAL);
   DrawGrayStr(1,29,"Out of Space, Out of Time.",A_NORMAL);
   DrawGrayStr(1,36,"This is a line out of one of E.Allen Poe's",A_NORMAL);
   DrawGrayStr(1,43,"famous poems. The fall of the house of ___",A_NORMAL);
   DrawGrayStr(1,50,"If you appreciate literature as much as your",A_NORMAL);
   DrawGrayStr(1,57,"life, you should know the name of the poem",A_NORMAL);
   DrawGrayStr(1,64,"Good Luck. - Xavier Delacroix",A_NORMAL);
	   
   FAT_AllKeysReleased();
   FAT_WaitKeyPressed();
   FAT_AllKeysReleased();

  }
  
if (havepaper==1 && fc.map_data == map)
  {
   
   FontSetSys(F_4x6);
   ClearGrayScreen();

   DrawGrayStr(1,1,"Quote the ______ nevermore",A_NORMAL);
	 DrawGrayStr(1,8,"-Xavier Delacroix",A_NORMAL);

   FAT_AllKeysReleased();
   FAT_WaitKeyPressed();
   FAT_AllKeysReleased();
   
  }
 if (havepaper == 1 && fc.map_data == map3)
  {

   FontSetSys(F_4x6);
   ClearGrayScreen();
   
   DrawGrayStr(1,1,"Well, you certainly have a brain in that",A_NORMAL);
   DrawGrayStr(1,8,"head of yours... somewhere. From here on",A_NORMAL);
   DrawGrayStr(1,15,"the clues get harder. Let's just see how",A_NORMAL);
   DrawGrayStr(1,22,"long you manage to stay alive!",A_NORMAL);
   DrawGrayStr(1,29,"-Xavier Delacroix",A_NORMAL);
 
   FAT_AllKeysReleased();
   FAT_WaitKeyPressed();
   FAT_AllKeysReleased();
 
  }
 if (havebook == 1 && fc.map_data == map3)
  {

   FontSetSys(F_4x6);
   ClearGrayScreen();
   
   DrawGrayStr(1,1,"What has a bed but never sleeps,",A_NORMAL);
   DrawGrayStr(1,8,"What has a mouth but never talks,",A_NORMAL);
   DrawGrayStr(1,15,"What always runs, but never walks?",A_NORMAL);
   DrawGrayStr(1,22,"-Xavier Delacroix",A_NORMAL);
   
 	 FAT_AllKeysReleased();
   FAT_WaitKeyPressed();
   FAT_AllKeysReleased();


  }
 if (havepaper == 1 && fc.map_data == map4 && havedecoder == 1)
  {

   FontSetSys(F_4x6);
 	 ClearGrayScreen();
   
   DrawGrayStr(1,1,"What is black, but has no color,",A_NORMAL);
   DrawGrayStr(1,8,"What can you see, but is not there,",A_NORMAL);
   DrawGrayStr(1,15,"What is the only container that dissapears",A_NORMAL);
   DrawGrayStr(1,22,"when you fill it?",A_NORMAL);
   DrawGrayStr(1,29,"One answer answers all these questions...",A_NORMAL);
   DrawGrayStr(1,36,"-Xavier Delacroix",A_NORMAL);
   
 	 FAT_AllKeysReleased();
   FAT_WaitKeyPressed();
   FAT_AllKeysReleased();
 
 
  }
  if (havepaper == 1 && fc.map_data == map4 && havedecoder == 0)
  {

   FontSetSys(F_4x6);
 	 ClearGrayScreen();
 	  
   DrawGrayStr(1,1,"13445569879987666545643311331232748",A_NORMAL);
   DrawGrayStr(1,8,"C4a4s5d66gWALLDDHCa3564g5sWOOOTRRTT",A_NORMAL);
   DrawGrayStr(1,15,"s3t4w6q9t6w4e5w3q3c5gh6aseh46srt46",A_NORMAL);
   DrawGrayStr(1,22,"asd48wyh4w6a87h",A_NORMAL);
   DrawGrayStr(1,29,"aeef246w3488SJE555",A_NORMAL);
   DrawGrayStr(1,36,"-Xavier Delacroix",A_NORMAL);

 	 FAT_AllKeysReleased();
   FAT_WaitKeyPressed();
   FAT_AllKeysReleased();

   
  }
  if (havepaper == 1 && fc.map_data == map5 && havedecoder == 1)
  {

   FontSetSys(F_4x6);
	 ClearGrayScreen();  
   
   DrawGrayStr(1,1,"They have not flesh, nor feathers, nor scales,",A_NORMAL);
   DrawGrayStr(1,8," nor bone. Yet they have fingers and thumbs",A_NORMAL);
   DrawGrayStr(1,15,"of their own.",A_NORMAL);
   DrawGrayStr(1,22,"What are they?",A_NORMAL);
   DrawGrayStr(1,29,"-Xavier Delacroix",A_NORMAL);
   
 	 FAT_AllKeysReleased();
   FAT_WaitKeyPressed();
   FAT_AllKeysReleased();

  }
  if (havepaper == 1 && fc.map_data == map5 && havedecoder == 0)
   {

   
   FontSetSys(F_4x6);
   ClearGrayScreen();
   
   DrawGrayStr(1,1,"13445569879987666545643311331232748",A_NORMAL);
   DrawGrayStr(1,8,"C4a4s5d66gWALLDDHCa3564g5sWOOOTRRTT",A_NORMAL);
   DrawGrayStr(1,15,"s3t4w6q9t6w4e5w3q3c5gh6aseh46srt46",A_NORMAL);
   DrawGrayStr(1,22,"asd48wyh4w6a87h",A_NORMAL);
   DrawGrayStr(1,29,"aeef246w3488SJE555",A_NORMAL);
   DrawGrayStr(1,36,"-Xavier Delacroix",A_NORMAL);
   
 	 FAT_AllKeysReleased();
   FAT_WaitKeyPressed();
   FAT_AllKeysReleased();


   }
  if (havepaper == 1 && fc.map_data == map6 && havedecoder == 0)
  {

   FontSetSys(F_4x6);
	 ClearGrayScreen();
	    
   DrawGrayStr(1,1,"X1hed2368FFCCEE156788sssF@#%!)(($",A_NORMAL);
   DrawGrayStr(1,8," !!))@(#*^^^@ASBC3345SS&&&3#$))$$",A_NORMAL);
   DrawGrayStr(1,15,"BC***#(((@)#12$115**X8999ccb",A_NORMAL);
   DrawGrayStr(1,22,"BC(((###***$*@^^@^@^#))$(($&",A_NORMAL);
   DrawGrayStr(1,29,"I have encrypted this clue, in order to",A_NORMAL);
   DrawGrayStr(1,36,"decrypt it you must find the decoder glasses.",A_NORMAL);
   DrawGrayStr(1,43,"-Xavier Delacroix",A_NORMAL);
   
 	 FAT_AllKeysReleased();
   FAT_WaitKeyPressed();
   FAT_AllKeysReleased();
   

  }
  if (havepaper == 1 && fc.map_data == map6 && havedecoder == 1)
  {

   FontSetSys(F_4x6);
	 ClearGrayScreen();
	    
   DrawGrayStr(1,1,"When you stop and look, you can always see",A_NORMAL);
   DrawGrayStr(1,8,"me. If you try to touch you cannot feel me.",A_NORMAL);
   DrawGrayStr(1,15,"I cannot move, but as you near me,",A_NORMAL);
   DrawGrayStr(1,22,"I will move away from you.",A_NORMAL);
   DrawGrayStr(1,29,"What am I?",A_NORMAL);
   DrawGrayStr(1,36,"-The answer is one word, dont make things",A_NORMAL);
   DrawGrayStr(1,43,"more difficult than they need be.",A_NORMAL);
   DrawGrayStr(1,50,"-Xavier Delacroix",A_NORMAL);
   
 	 FAT_AllKeysReleased();
   FAT_WaitKeyPressed();
   FAT_AllKeysReleased();

  }

if (havebook == 1 && fc.map_data == map7)
  {

   FontSetSys(F_4x6);
   ClearGrayScreen();
     
   DrawGrayStr(1,1,"You may notice this is a very large floor,",A_NORMAL);
   DrawGrayStr(1,8,"this is the 7th floor of the sub basement.",A_NORMAL);
   DrawGrayStr(1,15,"And you thought you were on one of the",A_NORMAL);
   DrawGrayStr(1,22,"main floors did'nt you? HA! There are many",A_NORMAL);
   DrawGrayStr(1,29,"locked doors on this level of the mansion.",A_NORMAL);
   DrawGrayStr(1,36,"Not every door can be opened with the",A_NORMAL);
   DrawGrayStr(1,43,"skeleton key as on previous floors.",A_NORMAL);
   DrawGrayStr(1,50," I have hidden several keys around this ",A_NORMAL);
   DrawGrayStr(1,57,"floor, along with the usual gambit of clues.",A_NORMAL);
   DrawGrayStr(1,64,"You have to find the keys in the right sequence",A_NORMAL);
   DrawGrayStr(1,71,"to unlock all the doors.",A_NORMAL);
   DrawGrayStr(1,78,"Are you having fun yet?",A_NORMAL);
   DrawGrayStr(1,85,"Too bad! i'm having a blast!",A_NORMAL);
   DrawGrayStr(1,92,"-Xavier Delacroix",A_NORMAL);
   	
 	 FAT_AllKeysReleased();
   FAT_WaitKeyPressed();
   FAT_AllKeysReleased();
   
  }
  
if (havepaper == 1 && fc.map_data == map7)
  {
   
   FontSetSys(F_4x6);
   ClearGrayScreen();
   
   DrawGrayStr(1,1,"We are little creatures;",A_NORMAL);
   DrawGrayStr(1,8,"all of us have different features.",A_NORMAL);
   DrawGrayStr(1,15,"One of us in glass is set; ",A_NORMAL);
   DrawGrayStr(1,22,"one of us you'll find in jet.",A_NORMAL);
   DrawGrayStr(1,29,"Another you may see in tin,",A_NORMAL);
   DrawGrayStr(1,36,"and the fourth is boxed within.",A_NORMAL);
   DrawGrayStr(1,43,"If the fifth you should pursue,",A_NORMAL);
   DrawGrayStr(1,50,"it can never fly from you. ",A_NORMAL);
   DrawGrayStr(1,57,"What are we?",A_NORMAL);
   DrawGrayStr(1,64,"-Xavier Delacroix",A_NORMAL);
   	
 	 FAT_AllKeysReleased();
   FAT_WaitKeyPressed();
   FAT_AllKeysReleased();
   
 }
  
  if (havepaper == 1 && fc.map_data == map8)
  {
 
   FontSetSys(F_4x6);
   ClearGrayScreen();
   
   DrawGrayStr(1,1,"the gunslinger C ame awake from a",A_NORMAL);
   DrawGrayStr(1,8,"c O nfused dream which seemed to ",A_NORMAL);
   DrawGrayStr(1,15,"consist of a single image:",A_NORMAL);
   DrawGrayStr(1,22,"that of the sailor in the tarot deck",A_NORMAL);
   DrawGrayStr(1,29,"from which the man in B lack had dealt",A_NORMAL);
   DrawGrayStr(1,36,"(or pu R ported to deal) the ",A_NORMAL);
   DrawGrayStr(1,43,"gunslinger's own mo A ning future.",A_NORMAL);
   DrawGrayStr(1,50,"-from The Drawing Of the Three, by",A_NORMAL);
   DrawGrayStr(1,57,"Stephen King.",A_NORMAL);
   DrawGrayStr(1,64,"Hope you are still paying attention!",A_NORMAL);
   DrawGrayStr(1,71,"-Xavier Delcroix",A_NORMAL);
   	
 	 FAT_AllKeysReleased();
   FAT_WaitKeyPressed();
   FAT_AllKeysReleased();
    
  }
  
  if (havebook == 1 && fc.map_data == map9)
  {
 
   FontSetSys(F_4x6);
   ClearGrayScreen();
   
   DrawGrayStr(1,1,"Hmm... you are more motivated than",A_NORMAL);
   DrawGrayStr(1,8,"I originally estimated.",A_NORMAL);
   DrawGrayStr(1,15,"No matter, there's still no chance",A_NORMAL);
   DrawGrayStr(1,22,"of escape. I still have a few tricks",A_NORMAL);
   DrawGrayStr(1,29,"up my sleve.",A_NORMAL);
   DrawGrayStr(1,36,"Perhaps you will turn out to be",A_NORMAL);
   DrawGrayStr(1,43,"craftier than i previously estimated",A_NORMAL);
   DrawGrayStr(1,50,"as well...",A_NORMAL);
   DrawGrayStr(1,57,"Time will tell i suppose.",A_NORMAL);
   DrawGrayStr(1,64,"I'm amazed you made it this far.",A_NORMAL);
   DrawGrayStr(1,71,"-Xavier Delcroix",A_NORMAL);
   	
 	 FAT_AllKeysReleased();
   FAT_WaitKeyPressed();
   FAT_AllKeysReleased();
    
  }
  
  if (havepaper == 1 && fc.map_data == map9)
  {
 
   FontSetSys(F_4x6);
   ClearGrayScreen();
   
   DrawGrayStr(1,1,"Hmm... you are more motiwated than",A_NORMAL);
   DrawGrayStr(1,8,"I origenally estimated.",A_NORMAL);
   DrawGrayStr(1,15,"No matter, there's still nc chance",A_NORMAL);
   DrawGrayStr(1,22,"of escape. I stitl have a few tricks",A_NORMAL);
   DrawGrayStr(1,29,"up my sleve.",A_NORMAL);
   DrawGrayStr(1,36,"Perhaps you woll turn out to be",A_NORMAL);
   DrawGrayStr(1,43,"craftier thar i previously estimated",A_NORMAL);
   DrawGrayStr(1,50,"as well...",A_NORMAL);
   DrawGrayStr(1,57,"-things are not always as they seem..-",A_NORMAL);
   DrawGrayStr(1,64,"-or as they should be...-",A_NORMAL);
   DrawGrayStr(1,71,"-Xavier Delcroix",A_NORMAL);
   	
 	 FAT_AllKeysReleased();
   FAT_WaitKeyPressed();
   FAT_AllKeysReleased();
    
  }
  if (havepaper == 1 && fc.map_data == map10 && havedecoder == 0)
  {

   FontSetSys(F_4x6);
	 ClearGrayScreen();
	    
   DrawGrayStr(1,1,"X1hed2368FFCCEE156788sssF@#%!)(($",A_NORMAL);
   DrawGrayStr(1,8," !!))@(#*^^^@ASBC3345SS&&&3#$))$$",A_NORMAL);
   DrawGrayStr(1,15,"BC***#(((@)#12$115**X8999ccb",A_NORMAL);
   DrawGrayStr(1,22,"BC(((###***$*@^^@^@^#))$(($&",A_NORMAL);
   DrawGrayStr(1,29,"I have encrypted this clue, in order to",A_NORMAL);
   DrawGrayStr(1,36,"decrypt it you must find the decoder glasses.",A_NORMAL);
   DrawGrayStr(1,43,"-Xavier Delacroix",A_NORMAL);
   
 	 FAT_AllKeysReleased();
   FAT_WaitKeyPressed();
   FAT_AllKeysReleased();
   

  }
  if (havepaper == 1 && fc.map_data == map10 && havedecoder == 1)
  {

   FontSetSys(F_4x6);
	 ClearGrayScreen();
	    
   DrawGrayStr(1,1,"The beginning of eternity",A_NORMAL);
   DrawGrayStr(1,8,"The end of time and space",A_NORMAL);
   DrawGrayStr(1,15,"The beginning of every end,",A_NORMAL);
   DrawGrayStr(1,22,"And the end of every place.",A_NORMAL);
   DrawGrayStr(1,29,"-Xavier Delacroix",A_NORMAL);
   
 	 FAT_AllKeysReleased();
   FAT_WaitKeyPressed();
   FAT_AllKeysReleased();
   

  }
  
  if (havepaper == 1 && fc.map_data == map11 && havedecoder == 0)
  {

   FontSetSys(F_4x6);
	 ClearGrayScreen();
	    
   DrawGrayStr(1,1,"X1hed2368FFCCEE156788sssF@#%!)(($",A_NORMAL);
   DrawGrayStr(1,8," !!))@(#*^^^@ASBC3345SS&&&3#$))$$",A_NORMAL);
   DrawGrayStr(1,15,"BC***#(((@)#12$115**X8999ccb",A_NORMAL);
   DrawGrayStr(1,22,"BC(((###***$*@^^@^@^#))$(($&",A_NORMAL);
   DrawGrayStr(1,29,"I have encrypted this clue, in order to",A_NORMAL);
   DrawGrayStr(1,36,"decrypt it you must find the decoder glasses.",A_NORMAL);
   DrawGrayStr(1,43,"-Xavier Delacroix",A_NORMAL);
   
 	 FAT_AllKeysReleased();
   FAT_WaitKeyPressed();
   FAT_AllKeysReleased();
   

  }
  
	if (havepaper == 1 && fc.map_data == map11 && havedecoder == 1)
  {

   FontSetSys(F_4x6);
	 ClearGrayScreen();
	    
   DrawGrayStr(1,1,"Who makes it, has no need of it.",A_NORMAL);
   DrawGrayStr(1,8,"Who buys it, has no use for it.",A_NORMAL);
   DrawGrayStr(1,15,"Who uses it can neither see nor feel it.",A_NORMAL);
   DrawGrayStr(1,22,"-One Word...",A_NORMAL);
   DrawGrayStr(1,29,"-Xavier Delacroix",A_NORMAL);
   
 	 FAT_AllKeysReleased();
   FAT_WaitKeyPressed();
   FAT_AllKeysReleased();
   

  }
  
  if (havepaper == 1 && fc.map_data == map12 && havedecoder == 0)
  {

   FontSetSys(F_4x6);
	 ClearGrayScreen();
	    
   DrawGrayStr(1,1,"X1hed2368FFCCEE156788sssF@#%!)(($",A_NORMAL);
   DrawGrayStr(1,8," !!))@(#*^^^@ASBC3345SS&&&3#$))$$",A_NORMAL);
   DrawGrayStr(1,15,"BC***#(((@)#12$115**X8999ccb",A_NORMAL);
   DrawGrayStr(1,22,"BC(((###***$*@^^@^@^#))$(($&",A_NORMAL);
   DrawGrayStr(1,29,"I have encrypted this clue, in order to",A_NORMAL);
   DrawGrayStr(1,36,"decrypt it you must find the decoder glasses.",A_NORMAL);
   DrawGrayStr(1,43,"-Xavier Delacroix",A_NORMAL);
   
 	 FAT_AllKeysReleased();
   FAT_WaitKeyPressed();
   FAT_AllKeysReleased();
   

  }
  
  if (havepaper == 1 && fc.map_data == map12 && havedecoder == 1)
  {

   FontSetSys(F_4x6);
	 ClearGrayScreen();
	    
   DrawGrayStr(1,1,"I know a word of letters three.",A_NORMAL);
   DrawGrayStr(1,8,"Add two, and fewer there will be.",A_NORMAL);
   DrawGrayStr(1,15,"-Xavier Delacroix",A_NORMAL);
   
 	 FAT_AllKeysReleased();
   FAT_WaitKeyPressed();
   FAT_AllKeysReleased();
   

  }
  
  if (havebook == 1 && fc.map_data == map13)
  {
 
   FontSetSys(F_4x6);
   ClearGrayScreen();
   
   DrawGrayStr(1,1,"Well, you arent out of the woods",A_NORMAL);
   DrawGrayStr(1,8,"yet... but you've made it farther",A_NORMAL);
   DrawGrayStr(1,15,"than any of the others before you.",A_NORMAL);
   DrawGrayStr(1,22,"If you can survive this floor, the",A_NORMAL);
   DrawGrayStr(1,29,"elevator will take you to the lobby.",A_NORMAL);
   DrawGrayStr(1,36,"And, you'll be free to go.",A_NORMAL);
   DrawGrayStr(1,43,"It's been fun, but now it's almost done.",A_NORMAL);
   DrawGrayStr(1,50,"-Xavier Delcroix",A_NORMAL);
   	
 	 FAT_AllKeysReleased();
   FAT_WaitKeyPressed();
   FAT_AllKeysReleased();
    
  }
  
  if (havepaper == 1 && fc.map_data == map13 && havedecoder == 0)
  {

   FontSetSys(F_4x6);
	 ClearGrayScreen();
	    
   DrawGrayStr(1,1,"X1hed2368FFCCEE156788sssF@#%!)(($",A_NORMAL);
   DrawGrayStr(1,8," !!))@(#*^^^@ASBC3345SS&&&3#$))$$",A_NORMAL);
   DrawGrayStr(1,15,"BC***#(((@)#12$115**X8999ccb",A_NORMAL);
   DrawGrayStr(1,22,"BC(((###***$*@^^@^@^#))$(($&",A_NORMAL);
   DrawGrayStr(1,29,"I have encrypted this clue, in order to",A_NORMAL);
   DrawGrayStr(1,36,"decrypt it you must find the decoder glasses.",A_NORMAL);
   DrawGrayStr(1,43,"-Xavier Delacroix",A_NORMAL);
   
 	 FAT_AllKeysReleased();
   FAT_WaitKeyPressed();
   FAT_AllKeysReleased();
   

  }
  
  if (havepaper == 1 && fc.map_data == map13 && havedecoder == 1)
  {

   FontSetSys(F_4x6);
	 ClearGrayScreen();
	    
   DrawGrayStr(1,1,"Walk on the living, they don't even mumble.",A_NORMAL);
   DrawGrayStr(1,8,"Walk on the dead, they mutter and grumble.",A_NORMAL);
   DrawGrayStr(1,15,"What are they?",A_NORMAL);
   DrawGrayStr(1,22,"-Xavier Delacroix",A_NORMAL);
   
 	 FAT_AllKeysReleased();
   FAT_WaitKeyPressed();
   FAT_AllKeysReleased();
   

  }



  
  InitGUI(&frames_display);

}
    //-------------------------------------------------------------------------
    // check if loading failed ...
    //-------------------------------------------------------------------------
    if (!texfile || !src) {
        FAT_UnloadEngine();
        if (texfile) FAT_UnlockHandleOfFile(texfile);
        ST_helpMsg("ERROR: cannot textures from textures");
        return;
    }
 		//-------------------------------------------------------------------------
    // add doors defined in map
    //-------------------------------------------------------------------------
   
    
   

    

		//-------------------------------------------------------------------------
    // initialize sprite structure and setup its fields
    //-------------------------------------------------------------------------
   
   FAT_InitSprite(&sprites[0]);
    sprites[0].drawmode    = SPRITEMODE_SIZE64;
    sprites[0].nr_textures = 1;
    sprites[0].textures    = book_tex;
    sprites[0].xpos = 0;
 		sprites[0].ypos = 0;
    sprites[0].orientation = 0;
    sprites[0].angle = 0;
 
 	 FAT_InitSprite(&sprites[1]);
    sprites[1].drawmode    = SPRITEMODE_SIZE64;
    sprites[1].nr_textures = 1;
    sprites[1].textures    = box_tex;
   	sprites[1].xpos = 0;
    sprites[1].ypos = 0;
    sprites[1].orientation = 0;
    sprites[1].angle = 0;
   
   FAT_InitSprite(&sprites[2]);
    sprites[2].drawmode    = SPRITEMODE_SIZE64;
    sprites[2].nr_textures = 1;
    sprites[2].textures    = paper_tex;
   	sprites[2].xpos = 0;
    sprites[2].ypos = 0;
    sprites[2].orientation = 0;
    sprites[2].angle = 0;
    
    FAT_InitSprite(&sprites[3]);
    sprites[3].drawmode    = SPRITEMODE_UNUSED;
    sprites[3].nr_textures = 1;
    sprites[3].textures    = skeleton_tex;
   	sprites[3].xpos = 0;
    sprites[3].ypos = 0;
    sprites[3].orientation = 0;
    sprites[3].angle = 0;
    
    FAT_InitSprite(&sprites[4]);
    sprites[4].drawmode    = SPRITEMODE_UNUSED;
    sprites[4].nr_textures = 1;
    sprites[4].textures    = reaper_tex;
   	sprites[4].xpos = 0;
    sprites[4].ypos = 0;
    sprites[4].orientation = 0;
    sprites[4].angle = 0;
    
    FAT_InitSprite(&sprites[5]);
    sprites[5].drawmode    = SPRITEMODE_UNUSED;
    sprites[5].nr_textures = 1;
    sprites[5].textures    = huge_zombie_tex;
   	sprites[5].xpos = 0;
    sprites[5].ypos = 0;
    sprites[5].orientation = 0;
    sprites[5].angle = 0;
    
    FAT_InitSprite(&sprites[6]);
    sprites[6].drawmode    = SPRITEMODE_UNUSED;
    sprites[6].nr_textures = 1;
    sprites[6].textures    = glasses_tex;
   	sprites[6].xpos = 0;
    sprites[6].ypos = 0;
    sprites[6].orientation = 0;
    sprites[6].angle = 0;
    
    FAT_InitSprite(&sprites[7]);
  	sprites[7].drawmode    = SPRITEMODE_SIZE64;
 		sprites[7].nr_textures = 1;
 		sprites[7].textures    = key_tex;
 		sprites[7].xpos = 0;
    sprites[7].ypos = 0;
 		sprites[7].orientation = 0;
 		sprites[7].angle = 0;
 		//lamp 1
 		FAT_InitSprite(&sprites[8]);
  	sprites[8].drawmode    = SPRITEMODE_SIZE64;
 		sprites[8].nr_textures = 1;
 		sprites[8].textures    = &textures[31];
 		sprites[8].xpos = 0;
    sprites[8].ypos = 0;
 		sprites[8].orientation = 0;
 		sprites[8].angle = 0;
 		//lamp 2 
 		FAT_InitSprite(&sprites[9]);
  	sprites[9].drawmode    = SPRITEMODE_SIZE64;
 		sprites[9].nr_textures = 1;
 		sprites[9].textures    = &textures[31];
 		sprites[9].xpos = 0;
    sprites[9].ypos = 0;
 		sprites[9].orientation = 0;
 		sprites[9].angle = 0;
 		//desk
 		FAT_InitSprite(&sprites[10]);
  	sprites[10].drawmode    = SPRITEMODE_SIZE64;
 		sprites[10].nr_textures = 1;
 		sprites[10].textures    = &textures[33];
 		sprites[10].xpos = 0;
    sprites[10].ypos = 0;
 		sprites[10].orientation = 0;
 		sprites[10].angle = 0;
 		//armoir (cabinet)
 		FAT_InitSprite(&sprites[11]);
  	sprites[11].drawmode    = SPRITEMODE_SIZE64;
 		sprites[11].nr_textures = 1;
 		sprites[11].textures    = &textures[34];
 		sprites[11].xpos = 0;
    sprites[11].ypos = 0;
 		sprites[11].orientation = 0;
 		sprites[11].angle = 0;
 		//iron key
 		FAT_InitSprite(&sprites[12]);
  	sprites[12].drawmode    = SPRITEMODE_UNUSED;
 		sprites[12].nr_textures = 1;
 		sprites[12].textures    = &textures[37];
 		sprites[12].xpos = 0;
    sprites[12].ypos = 0;
 		sprites[12].orientation = 0;
 		sprites[12].angle = 0;
 		//white key
 		FAT_InitSprite(&sprites[13]);
  	sprites[13].drawmode    = SPRITEMODE_UNUSED;
 		sprites[13].nr_textures = 1;
 		sprites[13].textures    = &textures[38];
 		sprites[13].xpos = 0;
    sprites[13].ypos = 0;
 		sprites[13].orientation = 0;
 		sprites[13].angle = 0;
 		//crossbow
 		FAT_InitSprite(&sprites[14]);
  	sprites[14].drawmode    = SPRITEMODE_SIZE64;
 		sprites[14].nr_textures = 1;
 		sprites[14].textures    = crossbow_tex;
 		sprites[14].xpos = 0;
    sprites[14].ypos = 0;
 		sprites[14].orientation = 0;
 		sprites[14].angle = 0;
 		//charm
 		FAT_InitSprite(&sprites[15]);
  	sprites[15].drawmode    = SPRITEMODE_SIZE64;
 		sprites[15].nr_textures = 1;
 		sprites[15].textures    = charm_tex;
 		sprites[15].xpos = 0;
    sprites[15].ypos = 0;
 		sprites[15].orientation = 0;
 		sprites[15].angle = 0;
 		  
    
    
void CreateDoors(TEXCONFIG* tex_door, TEXCONFIG* tex_side,short lockeddoors[],short lockedirondoors[],short lockedwhitedoors[]) {
    short x, y;
    
    for (y=1; y<(fc.map_height-1); ++y) {
        for (x=1; x<(fc.map_width-1); ++x) {
        	if (fc.map_data[y*fc.map_width+x] == 126)
            {
            	fc.map_data[y*fc.map_width+x] = 127;
            	lockeddoors[y*fc.map_width+x] = 1; 
             }	
            else if (fc.map_data[y*fc.map_width+x] == 125)
            {
            	fc.map_data[y*fc.map_width+x] = 127;
            	lockedirondoors[y*fc.map_width+x] = 1; ; 
            }	
            else if (fc.map_data[y*fc.map_width+x] == 124)
            {
            	fc.map_data[y*fc.map_width+x] = 127;
            	lockedwhitedoors[y*fc.map_width+x] = 1; ; 
            }		
        }
      }
    
    for (y=1; y<(fc.map_height-1); ++y) {
        for (x=1; x<(fc.map_width-1); ++x) {
            if (fc.map_data[y*fc.map_width+x] == 127) {
                if (fc.map_data[y*fc.map_width+(x-1)]>0 && fc.map_data[y*fc.map_width+(x+1)]>0) {
                    FAT_AddDoor(x, y, DOOR_HORIZONTAL, DOOR_CLOSED, 0, tex_door, tex_side, NULL);
                }
                else {
                    FAT_AddDoor(x, y, DOOR_VERTICAL, DOOR_CLOSED, 0, tex_door, tex_side, NULL);
                }
            }
        }
    }

#if defined(FAT_USEDEBUG)
    y=0;
    FATDOOR* doors     = FAT_GetDoorsArray();
    short    doorcount = FAT_GetNrDoors();
    for (x=0,y=0;x<doorcount;x++,y+=5) {
        FAT_DebugUseSlot(y+0,"d.x",&(doors[x].xtile),FAT_DBG_SHORT_DEC);
        FAT_DebugUseSlot(y+1,"d.y",&(doors[x].ytile),FAT_DBG_SHORT_DEC);
        FAT_DebugUseSlot(y+2,"d.orient'n",&(doors[x].type),FAT_DBG_UCHAR_DEC);
        FAT_DebugUseSlot(y+3,"d.state",&(doors[x].state),FAT_DBG_UCHAR_DEC);
        FAT_DebugUseSlot(y+4,"d.position",&(doors[x].position),FAT_DBG_SHORT_DEC);
    }
#endif
}


///==============================================================================================
//==================================LEVEL INITIALIZATIONS========================================

void InitLevel1(void)
{
			havekey = 0; 
    	havepaper = 0;
    	havebook = 0;
    	switchon = 0;
    	havedecoder = 1;
    	sprites[0].drawmode = SPRITEMODE_SIZE64;
			sprites[1].drawmode = SPRITEMODE_SIZE64;
			sprites[2].drawmode = SPRITEMODE_SIZE64;
			sprites[3].drawmode = SPRITEMODE_UNUSED;
			sprites[4].drawmode = SPRITEMODE_UNUSED;
			sprites[5].drawmode = SPRITEMODE_UNUSED;
			sprites[6].drawmode = SPRITEMODE_UNUSED;
			sprites[7].drawmode = SPRITEMODE_SIZE64;
			sprites[8].drawmode = SPRITEMODE_SIZE64;
			sprites[9].drawmode = SPRITEMODE_SIZE64;
			sprites[10].drawmode = SPRITEMODE_SIZE64;
			sprites[11].drawmode = SPRITEMODE_SIZE64;
			sprites[12].drawmode = SPRITEMODE_UNUSED;
	 		sprites[13].drawmode = SPRITEMODE_UNUSED;
	 		sprites[14].drawmode = SPRITEMODE_SIZE64;
	 		sprites[15].drawmode = SPRITEMODE_SIZE64;
    	FAT_RemoveAllDoors();
    	fc.cam_orientation = ANGLE_EAST;
    	fc.cam_xpos = 96;
    	fc.cam_ypos = 96;
    	fc.map_data = map;
    	PutSprites(&fc,sprites);
    	CreateDoors(&textures[36],&textures[3],lockeddoors,lockedirondoors,lockedwhitedoors);
    	InitGUI(&frames_display);
    	return;
}
 
void InitLevel2(void)
{
			havekey = 0; 
    	havepaper = 0;
    	havebook = 0;
    	switchon = 0;
    	havedecoder = 1;
    	sprites[7].drawmode = SPRITEMODE_SIZE64;
    	sprites[2].drawmode = SPRITEMODE_UNUSED;
    	sprites[0].drawmode = SPRITEMODE_SIZE64;
    	sprites[1].drawmode = SPRITEMODE_SIZE64;
    	sprites[14].drawmode = SPRITEMODE_UNUSED;
    	sprites[15].drawmode = SPRITEMODE_SIZE64;
    	FAT_RemoveAllDoors();
    	fc.cam_orientation = ANGLE_EAST;
    	fc.cam_xpos = 96;
    	fc.cam_ypos = 96;
    	fc.map_data = map2;
    	PutSprites(&fc,sprites);
    	CreateDoors(&textures[36],&textures[4],lockeddoors,lockedirondoors,lockedwhitedoors);
    	InitGUI(&frames_display);
    	return;
}

void InitLevel3(void)
{
			havepaper = 0;
    	havebook = 0;
    	havekey = 0;
    	switchon = 0;
    	havedecoder = 1;
    	FAT_RemoveAllDoors();
    	fc.map_width = 16;
    	fc.map_height = 32;
    	sprites[7].drawmode = SPRITEMODE_SIZE64;
    	sprites[2].drawmode = SPRITEMODE_SIZE64;
    	sprites[0].drawmode = SPRITEMODE_SIZE64;
    	sprites[1].drawmode = SPRITEMODE_SIZE64;
    	sprites[14].drawmode = SPRITEMODE_SIZE64;
    	sprites[15].drawmode = SPRITEMODE_SIZE64;
    	fc.cam_orientation = ANGLE_SOUTH;
    	fc.cam_xpos = 96;
    	fc.cam_ypos = 96;
    	fc.map_data = map3;
    	PutSprites(&fc,sprites);
    	CreateDoors(&textures[36],&textures[2],lockeddoors,lockedirondoors,lockedwhitedoors);
    	InitGUI(&frames_display);
    	return;
}

void InitLevel4(void)
{
			havepaper = 0;
      havedecoder = 0;
    	havebook = 0;
    	switchon = 0;
    	FAT_RemoveAllDoors();
    	fc.map_width = 32;
    	fc.map_height = 16;
    	sprites[2].drawmode = SPRITEMODE_SIZE64;
    	sprites[6].drawmode = SPRITEMODE_SIZE64;
    	sprites[7].drawmode = SPRITEMODE_SIZE64;
    	sprites[0].drawmode = SPRITEMODE_UNUSED;
    	sprites[1].drawmode = SPRITEMODE_UNUSED;
    	sprites[8].drawmode = SPRITEMODE_SIZE64;
    	sprites[9].drawmode = SPRITEMODE_SIZE64;
    	sprites[10].drawmode = SPRITEMODE_SIZE64;
    	sprites[11].drawmode = SPRITEMODE_SIZE64;
    	sprites[14].drawmode = SPRITEMODE_SIZE64;
    	sprites[15].drawmode = SPRITEMODE_UNUSED;
    	fc.cam_orientation = ANGLE_SOUTH;
    	fc.cam_xpos = 96;
    	fc.cam_ypos = 96;
    	fc.map_data = map4;
    	PutSprites(&fc,sprites);
    	CreateDoors(&textures[36],&textures[2],lockeddoors,lockedirondoors,lockedwhitedoors);
    	InitGUI(&frames_display);
    	return;
} 

void InitLevel5(void)
{
			havekey=0;
      havepaper = 0;
    	havebook = 0;
    	switchon = 0;
    	havedecoder = 0;
    	FAT_RemoveAllDoors();
    	fc.map_width = 32;
    	fc.map_height = 32;
    	sprites[7].drawmode = SPRITEMODE_SIZE64;
    	sprites[8].drawmode = SPRITEMODE_SIZE64;
    	sprites[9].drawmode = SPRITEMODE_SIZE64;
    	sprites[10].drawmode = SPRITEMODE_SIZE64;
    	sprites[11].drawmode = SPRITEMODE_SIZE64;
    	sprites[2].drawmode = SPRITEMODE_SIZE64;
    	sprites[0].drawmode = SPRITEMODE_UNUSED;
    	sprites[1].drawmode = SPRITEMODE_UNUSED;
    	sprites[6].drawmode = SPRITEMODE_SIZE64;
    	sprites[14].drawmode = SPRITEMODE_SIZE64;
    	sprites[15].drawmode = SPRITEMODE_UNUSED;
    	fc.cam_orientation = ANGLE_EAST;
    	fc.cam_xpos = (96);
    	fc.cam_ypos = (96);
    	fc.map_data = map5;
    	PutSprites(&fc,sprites);
    	CreateDoors(&textures[36],&textures[17],lockeddoors,lockedirondoors,lockedwhitedoors);
    	InitGUI(&frames_display);
    	return;
}

void InitLevel6(void)
{
	   				havepaper = 0;
    				havebook = 0;
    				havedecoder = 0;
    				switchon = 0;
    				havekey = 0;
    				FAT_RemoveAllDoors();
    				fc.map_width = 32;
    				fc.map_height = 32;
    				sprites[7].drawmode = SPRITEMODE_SIZE64;
    				sprites[6].drawmode = SPRITEMODE_SIZE64;
    				sprites[2].drawmode = SPRITEMODE_SIZE64;
    				sprites[0].drawmode = SPRITEMODE_UNUSED;
    				sprites[1].drawmode = SPRITEMODE_UNUSED;
    				sprites[8].drawmode = SPRITEMODE_SIZE64;
    				sprites[9].drawmode = SPRITEMODE_SIZE64;
    				sprites[10].drawmode = SPRITEMODE_SIZE64;
    				sprites[11].drawmode = SPRITEMODE_SIZE64;
    				sprites[14].drawmode = SPRITEMODE_SIZE64;
    				sprites[15].drawmode = SPRITEMODE_SIZE64;
    				fc.cam_orientation = ANGLE_SOUTH;
    				fc.cam_xpos = (96);
   				 	fc.cam_ypos = (96);
  			  	fc.map_data = map6;
  			  	PutSprites(&fc,sprites);
   				 	CreateDoors(&textures[36],&textures[15],lockeddoors,lockedirondoors,lockedwhitedoors);
   				 	InitGUI(&frames_display);
         		return;
}

void InitLevel7(void)
{
						havepaper = 0;
    				havebook = 0;
    				havedecoder = 1;
    				switchon = 0;
    				havekey = 0;
    				haveironkey = 0;
    				havewhitekey = 0;
    				FAT_RemoveAllDoors();
    				fc.map_width = 32;
    				fc.map_height = 32;
    				sprites[7].drawmode = SPRITEMODE_SIZE64;
    				sprites[6].drawmode = SPRITEMODE_UNUSED;
    				sprites[2].drawmode = SPRITEMODE_SIZE64;
    				sprites[0].drawmode = SPRITEMODE_SIZE64;
    				sprites[1].drawmode = SPRITEMODE_UNUSED;
    				sprites[8].drawmode = SPRITEMODE_SIZE64;
    				sprites[9].drawmode = SPRITEMODE_SIZE64;
    				sprites[10].drawmode = SPRITEMODE_SIZE64;
    				sprites[11].drawmode = SPRITEMODE_SIZE64;
    				sprites[12].drawmode = SPRITEMODE_SIZE64;
    				sprites[13].drawmode = SPRITEMODE_SIZE64;
    				sprites[14].drawmode = SPRITEMODE_UNUSED;
    				sprites[15].drawmode = SPRITEMODE_SIZE64;
    				fc.cam_orientation = ANGLE_NORTH;
    				fc.cam_xpos = ((14*64)+96);
   				 	fc.cam_ypos = ((15*64)+96);
  			  	fc.map_data = map7;
  			  	PutSprites(&fc,sprites);
   				 	CreateDoors(&textures[36],&textures[35],lockeddoors,lockedirondoors,lockedwhitedoors);
   				 	InitGUI(&frames_display);
         		return;
}
 
void InitLevel8(void)
{
						
						havepaper = 0;
    				havebook = 0;
    				havedecoder = 1;
    				switchon = 0;
    				havekey = 0;
    				haveironkey = 0;
    				havewhitekey = 0;
    				FAT_RemoveAllDoors();
    				fc.map_width = 32;
    				fc.map_height = 32;
    				sprites[7].drawmode = SPRITEMODE_SIZE64;
    				sprites[6].drawmode = SPRITEMODE_UNUSED;
    				sprites[2].drawmode = SPRITEMODE_SIZE64;
    				sprites[0].drawmode = SPRITEMODE_SIZE64;
    				sprites[1].drawmode = SPRITEMODE_UNUSED;
    				sprites[8].drawmode = SPRITEMODE_SIZE64;
    				sprites[9].drawmode = SPRITEMODE_SIZE64;
    				sprites[10].drawmode = SPRITEMODE_SIZE64;
    				sprites[11].drawmode = SPRITEMODE_SIZE64;
    				sprites[12].drawmode = SPRITEMODE_SIZE64;
    				sprites[13].drawmode = SPRITEMODE_SIZE64;
    				sprites[14].drawmode = SPRITEMODE_SIZE64;
    				fc.cam_orientation = ANGLE_SOUTH;
    				fc.cam_xpos = (96);
   				 	fc.cam_ypos = (96);
  			  	fc.map_data = map8;
  			  	PutSprites(&fc,sprites);
   				 	CreateDoors(&textures[36],&textures[27],lockeddoors,lockedirondoors,lockedwhitedoors);
   				 	InitGUI(&frames_display);
         		return;
}

void InitLevel9(void)
{
						havepaper = 0;
    				havebook = 0;
    				havedecoder = 1;
    				switchon = 0;
    				havekey = 0;
    				haveironkey = 0;
    				havewhitekey = 0;
    				FAT_RemoveAllDoors();
    				fc.map_width = 32;
    				fc.map_height = 32;
    				sprites[7].drawmode = SPRITEMODE_SIZE64;
    				sprites[6].drawmode = SPRITEMODE_UNUSED;
    				sprites[2].drawmode = SPRITEMODE_SIZE64;
    				sprites[0].drawmode = SPRITEMODE_SIZE64;
    				sprites[1].drawmode = SPRITEMODE_UNUSED;
    				sprites[8].drawmode = SPRITEMODE_SIZE64;
    				sprites[9].drawmode = SPRITEMODE_SIZE64;
    				sprites[10].drawmode = SPRITEMODE_SIZE64;
    				sprites[11].drawmode = SPRITEMODE_SIZE64;
    				sprites[12].drawmode = SPRITEMODE_SIZE64;
    				sprites[13].drawmode = SPRITEMODE_SIZE64;
    				sprites[14].drawmode = SPRITEMODE_SIZE64;
    				fc.cam_orientation = ANGLE_EAST;
    				fc.cam_xpos = (96);
   				 	fc.cam_ypos = (96);
  			  	fc.map_data = map9;
  			  	PutSprites(&fc,sprites);
   				 	CreateDoors(&textures[36],&textures[16],lockeddoors,lockedirondoors,lockedwhitedoors);
   				 	InitGUI(&frames_display);
         		return;
} 

void InitLevel10(void)
{
						havepaper = 0;
    				havebook = 0;
    				havedecoder = 0;
    				switchon = 0;
    				havekey = 0;
    				haveironkey = 0;
    				havewhitekey = 0;
    				FAT_RemoveAllDoors();
    				fc.map_width = 32;
    				fc.map_height = 32;
    				sprites[7].drawmode = SPRITEMODE_SIZE64;
    				sprites[6].drawmode = SPRITEMODE_SIZE64;
    				sprites[2].drawmode = SPRITEMODE_SIZE64;
    				sprites[0].drawmode = SPRITEMODE_SIZE64;
    				sprites[1].drawmode = SPRITEMODE_UNUSED;
    				sprites[8].drawmode = SPRITEMODE_SIZE64;
    				sprites[9].drawmode = SPRITEMODE_SIZE64;
    				sprites[10].drawmode = SPRITEMODE_SIZE64;
    				sprites[11].drawmode = SPRITEMODE_SIZE64;
    				sprites[12].drawmode = SPRITEMODE_SIZE64;
    				sprites[13].drawmode = SPRITEMODE_SIZE64;
    				sprites[14].drawmode = SPRITEMODE_SIZE64;
    				sprites[15].drawmode = SPRITEMODE_SIZE64;
    				fc.cam_orientation = ANGLE_EAST;
    				fc.cam_xpos = (96);
   				 	fc.cam_ypos = (96);
  			  	fc.map_data = map10;
  			  	PutSprites(&fc,sprites);
   				 	CreateDoors(&textures[36],&textures[18],lockeddoors,lockedirondoors,lockedwhitedoors);
   				 	InitGUI(&frames_display);
         		return;
} 

void InitLevel11(void)
{
						havepaper = 0;
    				havebook = 0;
    				havedecoder = 0;
    				switchon = 0;
    				havekey = 0;
    				haveironkey = 0;
    				havewhitekey = 0;
    				FAT_RemoveAllDoors();
    				fc.map_width = 32;
    				fc.map_height = 32;
    				sprites[7].drawmode = SPRITEMODE_SIZE64;
    				sprites[6].drawmode = SPRITEMODE_SIZE64;
    				sprites[2].drawmode = SPRITEMODE_SIZE64;
    				sprites[0].drawmode = SPRITEMODE_UNUSED;
    				sprites[1].drawmode = SPRITEMODE_UNUSED;
    				sprites[8].drawmode = SPRITEMODE_SIZE64;
    				sprites[9].drawmode = SPRITEMODE_SIZE64;
    				sprites[10].drawmode = SPRITEMODE_SIZE64;
    				sprites[11].drawmode = SPRITEMODE_SIZE64;
    				sprites[12].drawmode = SPRITEMODE_SIZE64;
    				sprites[13].drawmode = SPRITEMODE_SIZE64;
    				sprites[14].drawmode = SPRITEMODE_SIZE64;
    				sprites[15].drawmode = SPRITEMODE_SIZE64;
    				fc.cam_orientation = ANGLE_SOUTH;
    				fc.cam_xpos = (96);
   				 	fc.cam_ypos = (96);
  			  	fc.map_data = map11;
  			  	PutSprites(&fc,sprites);
   				 	CreateDoors(&textures[36],&textures[18],lockeddoors,lockedirondoors,lockedwhitedoors);
   				 	InitGUI(&frames_display);
         		return;
} 

void InitLevel12(void)
{
						havepaper = 0;
    				havebook = 0;
    				havedecoder = 0;
    				switchon = 0;
    				havekey = 0;
    				haveironkey = 0;
    				havewhitekey = 0;
    				FAT_RemoveAllDoors();
    				fc.map_width = 32;
    				fc.map_height = 32;
    				sprites[7].drawmode = SPRITEMODE_SIZE64;
    				sprites[6].drawmode = SPRITEMODE_SIZE64;
    				sprites[2].drawmode = SPRITEMODE_SIZE64;
    				sprites[0].drawmode = SPRITEMODE_UNUSED;
    				sprites[1].drawmode = SPRITEMODE_UNUSED;
    				sprites[8].drawmode = SPRITEMODE_SIZE64;
    				sprites[9].drawmode = SPRITEMODE_SIZE64;
    				sprites[10].drawmode = SPRITEMODE_SIZE64;
    				sprites[11].drawmode = SPRITEMODE_SIZE64;
    				sprites[12].drawmode = SPRITEMODE_SIZE64;
    				sprites[13].drawmode = SPRITEMODE_SIZE64;
    				sprites[14].drawmode = SPRITEMODE_SIZE64;
    				sprites[15].drawmode = SPRITEMODE_SIZE64;
    				fc.cam_orientation = ANGLE_SOUTH;
    				fc.cam_xpos = (96);
   				 	fc.cam_ypos = (96);
  			  	fc.map_data = map12;
  			  	PutSprites(&fc,sprites);
   				 	CreateDoors(&textures[36],&textures[18],lockeddoors,lockedirondoors,lockedwhitedoors);
   				 	InitGUI(&frames_display);
         		return;
} 

void InitLevel13(void)
{
						havepaper = 0;
    				havebook = 0;
    				havedecoder = 0;
    				switchon = 0;
    				havekey = 0;
    				haveironkey = 0;
    				havewhitekey = 0;
    				FAT_RemoveAllDoors();
    				fc.map_width = 32;
    				fc.map_height = 32;
    				sprites[7].drawmode = SPRITEMODE_SIZE64;
    				sprites[6].drawmode = SPRITEMODE_SIZE64;
    				sprites[2].drawmode = SPRITEMODE_SIZE64;
    				sprites[0].drawmode = SPRITEMODE_SIZE64;
    				sprites[1].drawmode = SPRITEMODE_UNUSED;
    				sprites[8].drawmode = SPRITEMODE_SIZE64;
    				sprites[9].drawmode = SPRITEMODE_SIZE64;
    				sprites[10].drawmode = SPRITEMODE_SIZE64;
    				sprites[11].drawmode = SPRITEMODE_SIZE64;
    				sprites[12].drawmode = SPRITEMODE_SIZE64;
    				sprites[13].drawmode = SPRITEMODE_SIZE64;
    				sprites[14].drawmode = SPRITEMODE_SIZE64;
    				sprites[15].drawmode = SPRITEMODE_SIZE64;
    				fc.cam_orientation = ANGLE_SOUTH;
    				fc.cam_xpos = (96);
   				 	fc.cam_ypos = (96);
  			  	fc.map_data = map13;
  			  	PutSprites(&fc,sprites);
   				 	CreateDoors(&textures[36],&textures[18],lockeddoors,lockedirondoors,lockedwhitedoors);
   				 	InitGUI(&frames_display);
         		return;
} 
// AI stuff. MOVEMENT, COLISION,ETC



void AIHandler(FATCONFIG* fc,FATSPRITE* sprites,int tag)
{

//AI CODE HELP COURTESY OF MALCOLM SMITH. 
tag = (random(4)+1);
	
		if (tag == 1  && &sprites->xpos < &fc->map_width && (&sprites->ypos < &fc->map_height))
		{
			sprites->xpos = sprites->xpos + 4;
			sprites->ypos = sprites->ypos + 4;
		}
		if (tag == 2	&& sprites->xpos > 64 && &sprites->ypos < &fc->map_height)
		{
			sprites->xpos = sprites->xpos - 4;
			sprites->ypos = sprites->ypos + 4;
		}
		if (tag == 3	&& &sprites->xpos < &fc->map_width && sprites->ypos > 64)
		{
			sprites->xpos = sprites->xpos + 4;
			sprites->ypos = sprites->ypos - 4;
		}
		if (tag == 4	&& sprites->xpos > 64 && sprites->ypos > 64)
		{
			sprites->xpos = sprites->xpos - 4;
			sprites->ypos = sprites->ypos - 4;
		}		
		
int enemytile_x = (sprites->xpos / 64);
int enemytile_y = (sprites->ypos / 64);
int playertile_x = (fc->cam_xpos / 64);
int playertile_y = (fc->cam_ypos / 64);

		if (enemytile_x == playertile_x && enemytile_y == playertile_y && invincible !=1)
		{
			
			
  			if (lives != 0)
  			{
  				if (fc->map_data == map)
  				{
						
  					dissolve();
  					ClearGrayScreen();
  					InitLevel1();
	  				lives -= 1; 
  				}
  				if (fc->map_data == map2)
  				{
  					dissolve();
  					ClearGrayScreen();
  					InitLevel2();
	  				lives -= 1; 
  				}
  				if (fc->map_data == map3)
  				{	
  					dissolve();
  					ClearGrayScreen();  				
  					InitLevel3();
	 					lives -= 1; 
  				}
  				if (fc->map_data == map4)
  				{
  					dissolve();
  					ClearGrayScreen();
	  				InitLevel4();
  					lives -= 1; 
  				}
  				if (fc->map_data == map5)
  				{	
  					dissolve();
  					ClearGrayScreen();
	  				InitLevel5();
	  				lives -= 1; 
  				}
  				if (fc->map_data == map6)
  				{
  					dissolve();
  					ClearGrayScreen();
	  				InitLevel6();
	  				lives -= 1; 
  				}
  				if (fc->map_data == map7)
  				{
  					dissolve();
  					ClearGrayScreen();
	  				InitLevel7();
	  				lives -= 1; 
  				}
  				
  				if (fc->map_data == map8)
  				{
  					dissolve();
  					ClearGrayScreen();
	  				InitLevel8();
	  				lives -= 1; 
  				}
  				
  				if (fc->map_data == map9)
  				{
  					dissolve();
  					ClearGrayScreen();
	  				InitLevel9();
	  				lives -= 1; 
  				}
  				
  				if (fc->map_data == map10)
  				{
  					dissolve();
  					ClearGrayScreen();
	  				InitLevel10();
	  				lives -= 1; 
  				}
  				
  				if (fc->map_data == map11)
  				{
  					dissolve();
  					ClearGrayScreen();
	  				InitLevel11();
	  				lives -= 1; 
  				}
  				
  				if (fc->map_data == map12)
  				{
  					dissolve();
  					ClearGrayScreen();
	  				InitLevel12();
	  				lives -= 1; 
  				}
  				
  				if (fc->map_data == map13)
  				{
  					dissolve();
  					ClearGrayScreen();
	  				InitLevel13();
	  				lives -= 1; 
  				}
  				
  			}
  			else
  			{  			 			
  			FontSetSys(F_4x6);
   			ClearGrayScreen();
   			
   			DrawGrayStr(1,1,"You have been captured by a ghost. You must",A_NORMAL);
   			DrawGrayStr(1,8,"spend eternity in this place, as a captive",A_NORMAL);
   			DrawGrayStr(1,15,"of the undead. In this place you will never die.",A_NORMAL);
   			DrawGrayStr(1,22,"all of this brought to you by",A_NORMAL);
   			FontSetSys(F_8x10);
   			DrawGrayStr(32,48,"GAME OVER",A_NORMAL);
   			DrawGrayStr(8,38,"ZTheta Programming",A_NORMAL);
   			playerdead = 1;
   			
   			FAT_AllKeysReleased();
   			FAT_WaitKeyPressed();
   			FAT_AllKeysReleased();
   			
   			FadeOutToBlack_CWS1_R(GrayGetPlane(LIGHT_PLANE),GrayGetPlane(DARK_PLANE),LCD_HEIGHT,LCD_WIDTH,60);
   			}
    }		 
		
}


 
void InputHandler(int MaxLength,char code[18])
{	
int index = 0;
FontSetSys(F_6x8);
char *light_buffer, *dark_buffer;

					FAT_AllKeysReleased();


					if(!(light_buffer = (char*) malloc(LCD_SIZE)))
						{
							playerdead = 1;
   						return;
 						 //handle errors and return

						}

					if(!(dark_buffer = (char*) malloc(LCD_SIZE)))
						{

 						  playerdead = 1;
   						return;
 						 //handle errors and return

						}
				memcpy(light_buffer, GrayGetPlane(LIGHT_PLANE), LCD_SIZE);
  			memcpy(dark_buffer, GrayGetPlane(DARK_PLANE), LCD_SIZE);
				FontSetSys(F_6x8);

code[0]=' ';
code[1]=' ';
code[2]=' ';
code[3]=' ';
code[4]=' ';
code[5]=' ';
code[6]=' ';
code[7]=' ';
code[8]=' ';
code[9]=' ';
code[10]=' ';
code[11]=' ';
code[12]=' ';
code[13]=' ';
code[14]=' ';
code[15]=' ';
code[16]=' ';
	
	while (!_keytest(RR_ENTER))
	{
	
			 FAT_AllKeysReleased();		
  
   			GraySetAMSPlane((LIGHT_PLANE)); 
   			DrawStr(1,1,"Enter Elevator Code:",A_REPLACE);
   			DrawStr(16,32,code,A_REPLACE);
   			
   			
   			
   			GraySetAMSPlane((DARK_PLANE)); 
   			DrawStr(1,1,"Enter Elevator Code:",A_REPLACE);
   			DrawStr(16,32,code,A_REPLACE);
   			
   	if (_keytest(RR_EQUALS)&& index <= MaxLength)
   	{
   			code[index] =  'A';
   			code[index + 1] = 0;
				index++;
		}
		if (_keytest(RR_PAREN_OPEN)&& index <= MaxLength)
   	{
   			code[index] = 'B';
   			code[index + 1] = 0;
				index++;
		}
		if (_keytest(RR_PAREN_CLOSE)&& index <= MaxLength)
   	{
   			code[index] = 'C';
   			code[index + 1] = 0;
				index++;
		}
		if (_keytest(RR_COMMA)&& index <= MaxLength)
   	{
   			code[index] = 'D';
   			code[index + 1] = 0;
				index++;
		}
		if (_keytest(RR_DIVIDE)&& index <= MaxLength)
   	{
   			code[index] = 'E';
   			code[index + 1] = 0;
				index++;
		}
		if (_keytest(RR_WITH)&& index <= MaxLength)
   	{
   			code[index] = 'F';
   			code[index + 1] = 0;
				index++;
		}
		if (_keytest(RR_7)&& index <= MaxLength)
   	{
   			code[index] = 'G';
   			code[index + 1] = 0;
				index++;
		}
		if (_keytest(RR_8)&& index <= MaxLength)
   	{
   			code[index] = 'H';
   			code[index + 1] = 0;
				index++;
		}
		if (_keytest(RR_9)&& index <= MaxLength)
   	{
   			code[index] = 'I';
   			code[index + 1] = 0;
				index++;
		}
		if (_keytest(RR_MULTIPLY)&& index <= MaxLength)
   	{
   			code[index] = 'J';
   			code[index + 1] = 0;
				index++;
		}
		if (_keytest(RR_EE)&& index <= MaxLength)
   	{
   			code[index] = 'K';
   			code[index + 1] = 0;
				index++;
		}
		if (_keytest(RR_4)&& index <= MaxLength)
   	{
   			code[index] = 'L';
   			code[index + 1] = 0;
				index++;
		}
		if (_keytest(RR_5)&& index <= MaxLength)
   	{
   			code[index] = 'M';
   			code[index + 1] = 0;
				index++;
		}
		if (_keytest(RR_6)&& index <= MaxLength)
   	{
   			code[index] = 'N';
   			code[index + 1] = 0;
				index++;
		}
		if (_keytest(RR_MINUS)&& index <= MaxLength)
   	{
   			code[index] = 'O';
   			code[index + 1] = 0;
				index++;
		}
		if (_keytest(RR_STORE)&& index <= MaxLength)
   	{
   			code[index] = 'P';
   			code[index + 1] = 0;
				index++;
		}
		if (_keytest(RR_1)&& index <= MaxLength)
   	{
   			code[index] = 'Q';
   			code[index + 1] = 0;
				index++;
		}
		if (_keytest(RR_2)&& index <= MaxLength)
   	{
   			code[index] = 'R';
   			code[index + 1] = 0;
				index++;
		}
		if (_keytest(RR_3)&& index <= MaxLength)
   	{
   			code[index] = 'S';
   			code[index + 1] = 0;
				index++;
		}
		if (_keytest(RR_T)&& index <= MaxLength)
   	{
   			code[index] = 'T';
   			code[index + 1] = 0;
				index++;
		}
		if (_keytest(RR_PLUS)&& index <= MaxLength)
   	{
   			code[index] = 'U';
   			code[index + 1] = 0;
				index++;
		}
		if (_keytest(RR_0)&& index <= MaxLength)
   	{
   			code[index] = 'V';
   			code[index + 1] = 0;
				index++;
		}
		if (_keytest(RR_DOT)&& index <= MaxLength)
   	{
   			code[index] = 'W';
   			code[index + 1] = 0;
				index++;
		}
		if (_keytest(RR_X)&& index <= MaxLength)
   	{
   			code[index] = 'X';
   			code[index + 1] = 0;
				index++;
		}
		if (_keytest(RR_Y)&& index <= MaxLength)
   	{
   			code[index] = 'Y';
   			code[index + 1] = 0;
				index++;
		}
		if (_keytest(RR_Z)&& index <= MaxLength)
   	{
   			code[index] = 'Z';
   			code[index + 1] = 0;
				index++;
		}
		
		
}		
				
				FAT_AllKeysReleased();
   			FAT_WaitKeyPressed();
   			FAT_AllKeysReleased();
  			memcpy(GrayGetPlane(LIGHT_PLANE), light_buffer, LCD_SIZE);
  			memcpy(GrayGetPlane(DARK_PLANE), dark_buffer, LCD_SIZE);
		
		if(light_buffer) free(light_buffer);

  	if(dark_buffer) free(dark_buffer);
 	
	return;
}


 
 
void ElevatorHandler(FATCONFIG* fc,char code[18])
{
int MaxLength = 0;
char Map1Password[6] = "RAVEN";
char Map2Password[6] = "USHER";
char Map3Password[6] = "RIVER";
char Map4Password[5] = "HOLE";
char Map5Password[7] = "GLOVES";
char Map6Password[8] = "HORIZON";
char Map7Password[7] = "VOWELS";
char Map8Password[6] = "COBRA";
char Map9Password[7] = "VIOLIN";
char Map10Password[2] = "E";
char Map11Password[7] = "COFFIN";
char Map12Password[4] = "FEW";
char Map13Password[7] = "LEAVES";

long same;
//Handles Elevator // Temp location//
 		short tile_x = ((FAT_Cos16384(fc->cam_orientation) >> 8)+fc->cam_xpos)>>6;
    short tile_y = ((FAT_Sin16384(fc->cam_orientation) >> 8)+fc->cam_ypos)>>6;
 	
 	if (fc->map_data[((tile_y * fc->map_width) + tile_x)] == 15 && fc->map_data == map)
    {
    	MaxLength = 4;
    	InputHandler(MaxLength,code);
    	same = strcmp(code,Map1Password);
    	if (same == 0)
    	{
    		InitLevel2();
    	}
    }
    else  if (fc->map_data[((tile_y * fc->map_width) + tile_x)] == 15 && fc->map_data == map2)
    {
    	MaxLength = 4;
    	InputHandler(MaxLength,code);
    	same = strcmp(code,Map2Password);
    	if (same == 0)
    	{
    	InitLevel3();
    	}
    }
    else if (fc->map_data[((tile_y * fc->map_width) + tile_x)] == 15 && fc->map_data == map3)
    {
    	MaxLength = 4;
    	InputHandler(MaxLength,code);
    	same = strcmp(code,Map3Password);
    	if (same == 0)
    	{
    	InitLevel4();
    	}
    }
    else if (fc->map_data[((tile_y * fc->map_width) + tile_x)] == 15 && fc->map_data == map4)
    {
    	MaxLength = 3;
    	InputHandler(MaxLength,code);
    	same = strcmp(code,Map4Password);
    	if (same == 0)
    	{
    	InitLevel5();
    	}	
    }
    else if (fc->map_data[((tile_y * fc->map_width) + tile_x)] == 15 && fc->map_data == map5)
    {
    	MaxLength = 5;
    	InputHandler(MaxLength,code);
    	same = strcmp(code,Map5Password);
    	if (same == 0)
    	{
			InitLevel6();
    	}
    }
    else if (fc->map_data[((tile_y * fc->map_width) + tile_x)] == 15 && fc->map_data == map6)
    {	
    	MaxLength = 6;
    	InputHandler(MaxLength,code);
    	same = strcmp(code,Map6Password);
    	if (same == 0)
    	{
   		InitLevel7();
    	}
    }
    
    else if (fc->map_data[((tile_y * fc->map_width) + tile_x)] == 15 && fc->map_data == map7)
    {
    	MaxLength = 5;
    	InputHandler(MaxLength,code);
    	same = strcmp(code,Map7Password);
    	if (same == 0)
    	{
   		InitLevel8();
    	}
    }
    
    else if (fc->map_data[((tile_y * fc->map_width) + tile_x)] == 15 && fc->map_data == map8)
    {
    	MaxLength = 4;
    	InputHandler(MaxLength,code);
    	same = strcmp(code,Map8Password);
    	if (same == 0)
    	{
   		InitLevel9();
    	}
    }
    
    else if (fc->map_data[((tile_y * fc->map_width) + tile_x)] == 15 && fc->map_data == map9)
    {
    	MaxLength = 5;
    	InputHandler(MaxLength,code);
    	same = strcmp(code,Map9Password);
    	if (same == 0)
    	{
   		InitLevel10();
    	}
    }
    
    else if (fc->map_data[((tile_y * fc->map_width) + tile_x)] == 15 && fc->map_data == map10)
    {
    	MaxLength = 1;
    	InputHandler(MaxLength,code);
    	same = strcmp(code,Map10Password);
    	if (same == 0)
    	{
   		InitLevel11();
    	}
    }
    
    else if (fc->map_data[((tile_y * fc->map_width) + tile_x)] == 15 && fc->map_data == map11)
    {
    	MaxLength = 4;
    	InputHandler(MaxLength,code);
    	same = strcmp(code,Map11Password);
    	if (same == 0)
    	{
   		InitLevel12();
    	}
    }
    	
    else if (fc->map_data[((tile_y * fc->map_width) + tile_x)] == 15 && fc->map_data == map12)
    {
    	MaxLength = 3;
    	InputHandler(MaxLength,code);
    	same = strcmp(code,Map12Password);
    	if (same == 0)
    	{
   		InitLevel13();
    	}
    }
    
    else if (fc->map_data[((tile_y * fc->map_width) + tile_x)] == 15 && fc->map_data == map13)
    {
    	MaxLength = 6;
    	InputHandler(MaxLength,code);
    	same = strcmp(code,Map13Password);
    	if (same == 0)
    	{
   		playerdead=1;
    	}
    }
} 
 
 
 void HandleSprites(FATCONFIG* fc)
 {
 	
 	int index=0;
 	while (index<n)
 	{
 		
 		short sprite_x =(sprites[index].xpos);
 		short sprite_y =(sprites[index].ypos);
 		short cam_x = (fc->cam_xpos);
 		short cam_y = (fc->cam_ypos);

 			if (abs(cam_x-sprite_x) < 64 && abs(cam_y-sprite_y) < 64)
 			{
 			//	LCD_save(lcd);
 			if (index == 14)
 			{
 				havegun = 1;
 				if (sprites[14].drawmode != SPRITEMODE_UNUSED) arrows+=10;
 			}
 			
 			if (index == 15 && sprites[15].drawmode != SPRITEMODE_UNUSED)
 			{
 			havecharm += 1;
 			}
 			
 			if (index != 3 && index != 4 && index != 5 && index != 8 && index != 9 && index != 10 && index != 11)
 			{
 			sprites[index].drawmode = SPRITEMODE_UNUSED;
 			}
 			if (index == 0)
 			{
 				havebook = 1;
 			}
 			if (index == 12)
 			{
 				haveironkey = 1;
 			}
 			if (index == 13)
 			{
 				havewhitekey = 1;
 			}
 			if (index == 1 && havebox!=1 && fc->map_data != map8)
 			{
 					char *light_buffer, *dark_buffer;

					if(!(light_buffer = (char*) malloc(LCD_SIZE)))
						{
						
   						playerdead = 1;
   						return;
 						 //handle errors and return

						}

					if(!(dark_buffer = (char*) malloc(LCD_SIZE)))
						{

 						  playerdead = 1;
   						return;
 						 //handle errors and return

						}

 				havebox = 1;
 				memcpy(light_buffer, GrayGetPlane(LIGHT_PLANE), LCD_SIZE);
  			memcpy(dark_buffer, GrayGetPlane(DARK_PLANE), LCD_SIZE);
  			
   			FontSetSys(F_4x6);
   			ClearGrayScreen();
   			
   			DrawGrayStr(1,1,"You have found a pair of odd looking glasses...",A_NORMAL);
   			
   			FAT_AllKeysReleased();
   			FAT_WaitKeyPressed();
   			FAT_AllKeysReleased();
  			
  			memcpy(GrayGetPlane(LIGHT_PLANE), light_buffer, LCD_SIZE);
  			memcpy(GrayGetPlane(DARK_PLANE), dark_buffer, LCD_SIZE);
  			
  			if(light_buffer) free(light_buffer);

  			if(dark_buffer) free(dark_buffer);
 			}
 			
 			
 			if (index == 2)
 			{
 				havepaper = 1;
 			}
 			if (index == 6 && havedecoder != 1)
 			{
 			char *light_buffer, *dark_buffer;

					if(!(light_buffer = (char*) malloc(LCD_SIZE)))
						{
						
   						playerdead = 1;
   						return;
 						 //handle errors and return

						}

					if(!(dark_buffer = (char*) malloc(LCD_SIZE)))
						{

 						  playerdead = 1;
   						return;
 						 //handle errors and return

						}

 				memcpy(light_buffer, GrayGetPlane(LIGHT_PLANE), LCD_SIZE);
  			memcpy(dark_buffer, GrayGetPlane(DARK_PLANE), LCD_SIZE);
  			
   			FontSetSys(F_4x6);
				ClearGrayScreen();
				   			
   			DrawGrayStr(1,1,"Hmm... these glasses have buttons near the",A_NORMAL);
   			DrawGrayStr(1,8,"lenses, i wonder what they are for?",A_NORMAL);
   			
   			FAT_AllKeysReleased();
   			FAT_WaitKeyPressed();
   			FAT_AllKeysReleased();

  			memcpy(GrayGetPlane(LIGHT_PLANE), light_buffer, LCD_SIZE);
  			memcpy(GrayGetPlane(DARK_PLANE), dark_buffer, LCD_SIZE);
  			
  			if(light_buffer) free(light_buffer);

  			if(dark_buffer) free(dark_buffer);
  			
 				havedecoder = 1;
 			}
 			if (index == 7)
 			{
 				havekey = 1;
 			}
 			
 			}
 	index++;
 	}
 
 } 
 
void GlassesIndicator(void)
{

	if (USE_COUNTER != 1)
	{
		if (glasseson == 1)
		{
			FontSetSys(F_4x6);
		  DrawGrayStr(108+(display_offsetx),60+(display_offsety),"glasses on",A_XOR);
		}

		if (glasseson == 0)
		{
			FontSetSys(F_4x6);
		  DrawGrayStr(108+(display_offsetx),60+(display_offsety),"glasses off",A_XOR);
		}
	}

}



 
    //-------------------------------------------------------------------------
    // allocate space for a background image and fill the lower part of the
    // light plane with 0xff to simulate a floor ...
    //-------------------------------------------------------------------------

     if (!(bg_img = (unsigned short*)malloc(1152*2))) {
        FAT_UnloadEngine();
        FAT_UnlockHandleOfFile(texfile);
        ST_helpMsg("ERROR: out of mem");
        return;
    }
    memset(bg_img,0,1152*2);

    dest = bg_img;

    for (i=0;i<6;i++) {
        unsigned short* src = background+i;
        for (j=0;j<96;j++,dest++,src+=6) {
            *dest = *src;
            *(dest+576) = *(src+576);
        }
    }
    fc.background = bg_img;
    

		    InstallDummyHandlerForINTs();

    //-------------------------------------------------------------------------
    // initialize grayscales, clear both planes and set the destination plane
    // addresses for the FAT-Engine
    //-------------------------------------------------------------------------
    if (!GrayOn()) {
        free(bg_img);
        RestoreHandlerForINTs();
        FAT_UnloadEngine();
        FAT_UnlockHandleOfFile(texfile);
        ST_helpMsg("ERROR: out of mem");
        return;
    }
    
   
    
//ADDS THE DOORS *TESTING*
//=============================================================================
// add all doors defined in map
//=============================================================================
		if (fc.map_data != map2)
		{
		CreateDoors(&textures[36], &textures[3],lockeddoors,lockedirondoors,lockedwhitedoors);
		}

    //-------------------------------------------------------------------------
    // display the FAT-Engine's splashscreen
    //-------------------------------------------------------------------------
    FAT_DisplayLogo(100);

    fc.dest_plane0 = GetPlane(0)+30*2;  // center vertically
    fc.dest_plane1 = GetPlane(1)+30*2;  // center vertically
		
		int a;
		int b;
		int index = 0;
		
					
				void *virtual=malloc (60706);
        void *src2;
				PortSet(virtual, 239, 127);
				FontSetSys(F_6x8);
				memset(virtual,0x00,60706);
				DrawStr(1,92,"Your uncle has just died.",A_NORMAL);
				DrawStr(1,101,"In his will he left you ",A_NORMAL);
				DrawStr(1,110,"a mansion. you get to ",A_NORMAL);
				DrawStr(1,119,"keep it, on one condition",A_NORMAL);
				DrawStr(1,128,"you must live in the",A_NORMAL);
				DrawStr(1,137,"mansion. One night while",A_NORMAL);
				DrawStr(1,146,"reading in the study a ",A_NORMAL);
				DrawStr(1,155,"shadow forms on the book",A_NORMAL);
				DrawStr(1,164,"you are reading. Suddenly",A_NORMAL);
				DrawStr(1,173,"everything goes black...",A_NORMAL);
				DrawStr(1,200,"You wake up, your head",A_NORMAL);
				DrawStr(1,209,"throbs as you look around",A_NORMAL);
				DrawStr(1,218,"You find yourself in the",A_NORMAL);
				DrawStr(1,227,"basement of the mansion.",A_NORMAL);
				DrawStr(1,236,"You have never been in ",A_NORMAL);
				DrawStr(1,245,"this part of the mansion",A_NORMAL);
				DrawStr(1,254,"before. You walk around ",A_NORMAL);
				DrawStr(1,263,"and find all the doors ",A_NORMAL);
				DrawStr(1,272,"locked! Right then you",A_NORMAL);
				DrawStr(1,281,"know you must get out of",A_NORMAL);
				DrawStr(1,290,"the mansion. Something is",A_NORMAL);
				DrawStr(1,299,"wrong here...",A_NORMAL);
				DrawStr(1,335,"Welcome to 13ghosts!",A_NORMAL);
				DrawStr(1,344,"a world of secrets, clues,",A_NORMAL);
				DrawStr(1,353,"surprises, and evil.",A_NORMAL);
				DrawStr(1,362,"One thing you must remember",A_NORMAL);
				DrawStr(1,371,"things are not always as",A_NORMAL);
				DrawStr(1,380,"they seem...",A_NORMAL);
				
					 for (src2= virtual; src2+LCD_SIZE <= virtual + (LCD_SIZE*4) ; src2+=30) 
                {
                	index = 0;
                	while (index<1500)
                	{
                		a = random(900);
                		b = random(900);
                		index ++;
                	}
                if (_keytest(RR_ESC))
                {
                	break;
                }
                memcpy(GrayGetPlane(LIGHT_PLANE),src2,LCD_SIZE);
                memcpy(GrayGetPlane(DARK_PLANE),src2,LCD_SIZE);
                }
        free(virtual);
        FAT_AllKeysReleased();
        ClearGrayScreen();
   			

    //-------------------------------------------------------------------------
    // setup calculator type specials
    //-------------------------------------------------------------------------
    if (TI89) {
        display_offsetx = 0;
        display_offsety = 0;
    }
    else {
        // TI92p or V200
        display_offsetx  = 40;
        display_offsety  = 14;
        fc.dest_plane0  += (14*30+4)/2;
        fc.dest_plane1  += (14*30+4)/2;
    }

    //-------------------------------------------------------------------------
    // initialize the GUI
    //-------------------------------------------------------------------------
    InitGUI(&frames_display);
   	PutSprites(&fc,sprites);

    
    
typedef	struct
{
	 int ghostson;
   int havekey;
   int haveglasses;
   int havedecoder;
   int havepaper;
   int havebook;
   int switchon;
   int current_map;
   int cam_xpos;
   int cam_ypos;
   int cam_orientation;
   int map_width;
   int map_height;
   int glasses_on;
   int have_iron_key;
   int have_white_key;
   int have_charm;
   int lives;
   int havegun;
   int arrows;

} MyData;

static const char tag2[]={0,'G','H','O','S',0,OTH_TAG};

void Save(const MyData *data)
{
	
 //define the file structure
 FILES fsPtr;


if (FAccess("save13g",FM_WRITE_ACCESS,tag2) == FS_ERROR)
{
	EM_moveSymFromExtMem (SYMSTR("save13g"),HS_NULL);
}

 FOpen ("save13g", &fsPtr, FM_WRITE, "GHOS");
 
 FWrite (data, sizeof(MyData) , &fsPtr); 

 //insert code to write everything else to file here, map for instance...

 //close the file
 FClose (&fsPtr); 

}



void Load(FATCONFIG* fc,MyData *data)
{
 int mapdoor = 0;
 int maptile = 2;
 //define the file structure
 FILES fsPtr;
 
 if (FAccess("save13g",FM_READ_ACCESS,tag2) == FS_ERROR)
	{
	EM_moveSymFromExtMem ("save13g",HS_NULL );
	}
 //open he file in read mode
 FOpen ("save13g", &fsPtr, FM_READ, "GHOS");
 
 //read data from the file and save it to "data"
 FRead (data, sizeof(MyData) , &fsPtr);

		
    if (data->current_map == 1)
    {
    	fc->map_data = map;
    	mapdoor = 0;
    	maptile = 3;
    	InitLevel1();
    }
    if (data->current_map == 2)
    {
    	fc->map_data = map2;
    	mapdoor = 7;
    	maptile = 4;
    	InitLevel2();
    }
    if (data->current_map == 3)
    {
    	fc->map_data = map3;
    	mapdoor = 0;
    	maptile = 2;
    	InitLevel3();
    }
    if (data->current_map == 4)
    {
    	fc->map_data = map4;
    	mapdoor = 0;
    	maptile = 2;
    	InitLevel4();
    }
    if (data->current_map == 5)
    {
    	fc->map_data = map5;
    	mapdoor = 0;
    	maptile = 17;
    	InitLevel5();
    }
    if (data->current_map == 6)
    {
    	fc->map_data = map6;
    	mapdoor = 24;
    	maptile = 15;
    	InitLevel6();
    }
    if (data->current_map == 7)
    {
    	fc->map_data = map7;
    	mapdoor = 0;
    	maptile = 35;
    	InitLevel7();
    }
    if (data->current_map == 8)
    {
    	fc->map_data = map8;
    	mapdoor = 36;
    	maptile = 27;
    	//InitLevel8();
    }
    
    ghostson = data->ghostson;
    havekey = data->havekey;
    havebox = data->haveglasses;
    havedecoder = data->havedecoder;
    havepaper = data->havepaper;
    havebook = data->havebook;
    switchon = data->switchon;
    fc->cam_xpos = data->cam_xpos;
    fc->cam_ypos = data->cam_ypos;
    fc->cam_orientation = data->cam_orientation;
    fc->map_width = data->map_width;
    fc->map_height = data->map_height;
    glasseson = data->glasses_on;
    havewhitekey = data->have_white_key;
    haveironkey = data->have_iron_key;
    havecharm = data->have_charm;
    lives = data->lives;
    havegun = data->havegun;
    arrows = data->arrows;
    
    if (glasseson == 1)
    {
    	sprites[3].drawmode = SPRITEMODE_SIZE64;
      sprites[4].drawmode = SPRITEMODE_SIZE64;
      sprites[5].drawmode = SPRITEMODE_SIZE64;
    }
    
	 //insert code to read everything else from file here, map for instance...

 //close the file
 FClose (&fsPtr); 

}



     //-------------------------------------------------------------------------
    // the main rendering loop ...
    //-------------------------------------------------------------------------
do {
    	
    	timer++;
    	
    	if (shooting == 1)
    	{
    		FAT_SetHUD(NULL,NULL,NULL);
    		FAT_SetHUD(hud2_plane1,hud2_plane2,hud_mask2);
    			if (ShotHit(&fc,sprites,6) == 3 && immoble1 != 1) 
    			{
    			timer2 = 0;
    			immoble1 = 1;
         	}
         	if (ShotHit(&fc,sprites,6) == 4 && immoble2 != 1) 
         	{
         	timer3 = 0; 
         	immoble2 = 1;
         	}
         	if (ShotHit(&fc,sprites,6) == 5 && immoble3 != 1) 
         	{
         	timer4 = 0;
         	immoble3 = 1;
         	}
    	}
    	 if (timer == 3 && shooting == 1)
    	{
    		FAT_SetHUD(NULL,NULL,NULL);
    		FAT_SetHUD(hud_plane1,hud_plane2,hud_mask);
    		shooting = 0;
    	}
    	
    	if (timer == 10 && USE_COUNTER != 1)
    	{
    		InitGUI(&frames_display);
    		timer = 0;
    	}
    	
    	
    	printf_xy((136+display_offsetx),(36+display_offsety),"%d",lives,A_REPLACE);
    	printf_xy((142+display_offsetx),(45+display_offsety),"%d",arrows,A_REPLACE);
    		
    	 if (switchon == 1)
    	 {
    	 	 FAT_SetPredrawCallback(PredrawCallback);
    	 } 
    	 else if (switchon == 13 && fc.map_data == map13)
    	 {
    	 	FAT_SetPredrawCallback(PredrawCallback);
    	 }
    	 else
    	 {
    	 	FAT_SetPredrawCallback(NULL);
    	 }
    	 
    		if (playerdead == 1)
    		{
    			break;
    		}
    		
    	timer2++;
    	timer3++;
    	timer4++;	
    		
    	if (timer2 >= 30 && immoble1 == 1)
    	{
    		immoble1 = 0;
    		timer2 = 0;
    	} 
    	if (timer3 >= 30 && immoble2 == 1)
    	{
    		immoble2 = 0;
    		timer3 = 0;
    	}
    	if (timer4 >= 30 && immoble3 == 1)
    	{
    		immoble3 = 0;
    		timer4 = 0;
    	}
    	
    	if (timer2 >= 30 && immoble1 != 1)
    	{
    		timer2 = 0;
    	}
    	if (timer3 >= 30 && immoble2 != 1)
    	{
    		timer3 = 0;
    	}
    	if (timer4 >= 30 && immoble3 != 1)
    	{
    		timer4 = 0;
    	}
  
    		
if (fc.map_data == map)
{
	current_map = 1;
}
if (fc.map_data == map2)
{
	current_map = 2;
}
if (fc.map_data == map3)
{
	current_map = 3;
}
if (fc.map_data == map4)
{
	current_map = 4;
}
if (fc.map_data == map5)
{
	current_map = 5;
}
if (fc.map_data == map6)
{
	current_map = 6;
}
if (fc.map_data == map7)
{
	current_map = 7;
}
if (fc.map_data == map8)
{
	current_map = 8;
}
    		
MyData gamesave =	{
		ghostson,
    havekey,
    havebox,
    havedecoder,
    havepaper,
    havebook,
    switchon,
    current_map,
    fc.cam_xpos,
    fc.cam_ypos,
    fc.cam_orientation,
    fc.map_width,
    fc.map_height,
    ghostson,
    haveironkey,
    havewhitekey,
    havecharm,
    lives,
   	havegun,
   	arrows,
};
				
				
        FAT_Render(&fc);     // render image
        
       
        frame_drawn(&fc,&frames_display);  // handles frame counter drawing
				
				HandleSprites(&fc);
				HandleDoors(&fc);
				
				
        if (ghostson == 1)
        {
        if (immoble1 != 1) AIHandler(&fc,&fc.sprites[3],1);
       	if (immoble2 != 1) AIHandler(&fc,&fc.sprites[4],1);
       	if (immoble3 != 1) AIHandler(&fc,&fc.sprites[5],1);
        }
        
        
        if ((key = FAT_GetPadState())) {
            
            if (key & PADSTATE_ESC)    
            {
            FadeOutToBlack_CWS1_R(GrayGetPlane(LIGHT_PLANE),GrayGetPlane(DARK_PLANE),LCD_HEIGHT,LCD_WIDTH,60);
            break;
            }
            
            if (key & PADSTATE_UPDOWN) 
            {	
            PlayerMove(&fc,key & PADSTATE_UP,0);
						}	
						
					
						
            if (key & PADSTATE_LEFTRIGHT) {
                // STRAFE KEY: 2ND (TI-89) / F1 (TI-92p)
                if (key & PADSTATE_KB) {
                    PlayerMove(&fc,key&PADSTATE_RIGHT,1);
                }
                else {
                    PlayerTurn(&fc,key&PADSTATE_RIGHT,ANGLE_015/2);
                }
            }
            
         
            if (key & PADSTATE_KF || key & PADSTATE_APPS) {
                UpdateDoor(&fc,key & PADSTATE_KF);
                ElevatorHandler(&fc,code);
                UpdateSwitch(&fc);
                if (switchon == 1 && fc.map_data != map13)
                {
                UpdateSwitchDoor(&fc,textures,25);
                }
                else if (switchon == 13 && fc.map_data == map13)
                {
                	UpdateSwitchDoor(&fc,textures,25);
                }
                UpdateSecret(&fc,textures,13);
            }
            if (key & PADSTATE_KA) {
             bookhandler();
            }
            if (key & PADSTATE_KC && havebox == 1)
            {
            	if (glasseson == 0)
            	{
            		sprites[3].drawmode = SPRITEMODE_SIZE64;
            		sprites[4].drawmode = SPRITEMODE_SIZE64;
            		sprites[5].drawmode = SPRITEMODE_SIZE64;
            		glasseson = 1;
            		GlassesIndicator();
            	}
            	else {
            		sprites[3].drawmode = SPRITEMODE_UNUSED;
            		sprites[4].drawmode = SPRITEMODE_UNUSED;
            		sprites[5].drawmode = SPRITEMODE_UNUSED;
            		glasseson = 0;
            		GlassesIndicator();
            	}
            	FAT_AllKeysReleased();
            }
            if (key & PADSTATE_PLUS)
            {
            	OSContrastUp();
            }
            if (key & PADSTATE_MINUS)
            {
            	OSContrastDn();
            }        
         		if (key & PADSTATE_KD)
         		{
						
         		Save(&gamesave);
         		
         		}
         		
         		if (key & PADSTATE_KH)
         		{
         			
      			Load(&fc,&gamesave);
      			
         		}
         		
         		if (key & PADSTATE_KE) // && (havecharm == 1 || havegun == 1))
         		{
								if (usegun != 1 && havecharm>0) {
         				USE_COUNTER = 1;
         				InitGUI(&frames_display);
         				invincible = 1;
         				havecharm--;
         				}else if (shooting != 1 && arrows>0 && USE_COUNTER != 1)
         				{
         					timer = 0;
         					shooting = 1;
         					arrows-=1;
         				}
         				if (arrows == 0)
         				{
         					FAT_SetHUD(NULL,NULL,NULL);
         					usegun = 0;
         				}
         		
         		}
         		
         	
         		if (key & PADSTATE_KE && fc.map_data!=map8 && usegun != 1)
         		{
         		//InitLevel9();
    				}
    		
    				
    				if (key & PADSTATE_KG)
    				{
    					if (usegun == 0 && arrows>0)
    					{
    						usegun = 1;
    						FAT_SetHUD(hud_plane1,hud_plane2,hud_mask);
    						FAT_AllKeysReleased();
    					} else {	
    						usegun = 0;
    						FAT_SetHUD(NULL,NULL,NULL);
    						FAT_AllKeysReleased();
    					}
    				}
    				
  	}       			 
	
}  
while(1);


	//Closing Credits... Much due to many... ETC...///
	
				void *virtual2=malloc(60706);
        void *src3;
				PortSet(virtual2, 239, 127);
				FontSetSys(F_6x8);
				memset(virtual2,0x00,60706);
				DrawStr(1,92,"13Ghosts is (c) Warner ",A_NORMAL);
				DrawStr(1,101,"Brothers Inc.",A_NORMAL);
				DrawStr(1,110,"Coding: AARON MILLER",A_NORMAL);
				DrawStr(1,119,"Help with Coding:",A_NORMAL);
				DrawStr(1,128,"MALCOLM SMITH",A_NORMAL);
				DrawStr(1,137,"KEVIN KOFLER",A_NORMAL);
				DrawStr(1,146,"TI-Freakware Team.",A_NORMAL);
				DrawStr(1,155,"United Ti Members/Team",A_NORMAL);
				DrawStr(1,164,"TI-Chess Members",A_NORMAL);
				DrawStr(1,173,"Graphics:",A_NORMAL);
				DrawStr(1,182,"Artwork Modification:",A_NORMAL);
				DrawStr(1,191,"AARON MILLER",A_NORMAL);
				DrawStr(1,200,"Actual Artwork:",A_NORMAL);
				DrawStr(1,209,"Credit here goes to the",A_NORMAL);
				DrawStr(1,218,"respective artists of",A_NORMAL);
				DrawStr(1,227,"the ripped artwork.",A_NORMAL);
				DrawStr(1,236,"Some Actual Artwork:",A_NORMAL);
				DrawStr(1,245,"AARON MILLER",A_NORMAL);
				DrawStr(1,254,"Many thanks to those ",A_NORMAL);
				DrawStr(1,263,"involved with the develop",A_NORMAL);
				DrawStr(1,272,"ment of 13Ghosts! ",A_NORMAL);
				DrawStr(1,281,"Original Story:",A_NORMAL);
				DrawStr(1,290,"(c)Warner Brothers Inc.",A_NORMAL);
				DrawStr(1,299,"Game Concept and Modified",A_NORMAL);
				DrawStr(1,308,"Story: AARON MILLER",A_NORMAL);
				DrawStr(1,317,"Terror Has Multiplied -",A_NORMAL);
				DrawStr(1,326,"Trademark Warnerbrothers",A_NORMAL);
				DrawStr(1,335,"Inc.",A_NORMAL);
				DrawStr(1,398,"    Thanks For Playing",A_NORMAL);
				
					 for (src3= virtual2; src3+LCD_SIZE <= virtual2 + (LCD_SIZE*4) ; src3+=30) 
                {
                	index = 0;
                	while (index<1500)
                	{
                		a = random(900);
                		b = random(900);
                		index ++;
                	}
                if (_keytest(RR_ESC))
                {
                	break;
                }
                memcpy(GrayGetPlane(LIGHT_PLANE),src3,LCD_SIZE);
                memcpy(GrayGetPlane(DARK_PLANE),src3,LCD_SIZE);
                }
        free(virtual2);
        FAT_AllKeysReleased();
        ClearGrayScreen();
   			
    //-------------------------------------------------------------------------
    // some clean stuff ...
    //-------------------------------------------------------------------------
    
    FAT_AllKeysReleased();
    GrayOff();
    free(bg_img);
    FAT_RemoveAllDoors();
    LCD_restore(lcd);
    ST_helpMsg(FAT_GetPoweredByString());
    FAT_UnlockHandleOfFile(texfile);  // unlock texture file
    FAT_UnloadEngine();
    RestoreHandlerForINTs();
    OSqclear(kbd_queue());
}

//#############################################################################
// Revision History
//#############################################################################
//
// $Log: fatd1.c,v $
// Revision 1.16  2002/05/08 15:35:13  tnussb
// (1) display of FAT splashscreen (FAT_DisplayLogo) added
// (2) GUI of demos completely revised
//
// Revision 1.15  2002/05/07 15:22:12  tnussb
// stupid double call of FAT_LoadEngine() fixed
//
// Revision 1.14  2002/04/30 17:41:44  tnussb
// using now defines from automatically generated headerfile indices.h for indices into
// our texture file
//
// Revision 1.13  2002/04/26 13:10:49  tnussb
// if FAT_LoadEngine() fails different strings will be displayed yet
//
// Revision 1.12  2002/04/25 19:26:38  tnussb
// generic commit for engine version v1.05
//
// Revision 1.11  2002/04/24 17:41:54  tnussb
// (1) using now FAT_GetPadState() to query key presses
// (2) movement evaluation block rewritten (handles now strafing, too)
//
// Revision 1.10  2002/04/18 12:14:47  tnussb
// using now fatdtx texture file instead of embedded textures
//
// Revision 1.9  2002/04/16 11:36:37  tnussb
// All calls to GrayMode() replaced by GrayOn/GrayOff calls
//
// Revision 1.8  2002/04/08 20:18:16  tnussb
// using now signed char (instead of unsigned char) for map
//
// Revision 1.7  2002/03/26 11:56:24  tnussb
// all warnings reported by -Wall fixed
//
// Revision 1.6  2002/03/11 09:17:40  tnussb
// USE_V200 added
//
// Revision 1.5  2002/03/07 11:13:51  tnussb
// restores now previously set font at the end
//
// Revision 1.4  2002/03/06 12:32:12  tnussb
// (1) OutputTitle completely rewritten (uses now new exported "functions" of FAT-Engine)
// (2) InstallDummyHandleForINT1(), RestoreHandlerForINT1() renamed, because AUTO_INT5 will be redirected now, too
// (3) don't use SAVE_SCREEN anymore, but use own screenbackup to enable writting to the statusline
//
// Revision 1.3  2002/03/01 11:09:55  tnussb
// generic commit for sourcecode release v0.81
//
// Revision 1.2  2001/03/11 19:16:24  Thomas Nussbaumer
// using now _rowread() and smaller delta values
//
// Revision 1.1  2001/03/04 20:13:38  Thomas Nussbaumer
// initial version
//
//


